#!/usr/bin/perl

##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# gallery.cgi
#$StartTime = time();	#For debugging purposes
# flush the buffers
$|=1;
# find if it is a windows operating system
my($dpath);
my($windows);

if ( ($^O eq 'MSWin32') || defined($ENV{'OS'}) ) {
      # this one for windows
      $windows = "true";
      $dpath= "$ENV{'PATH_TRANSLATED'}";
      $dpath =~ s/\\$GalleryCgi$//g;
      $slash = '\\';
}else{
      # this one for unix type
      $windows = "false";
      $dpath = "$ENV{'SCRIPT_FILENAME'}";
      $dpath =~ s/\/$GalleryCgi$//g;
      $slash = '/';
}

push (@INC, "$dpath");

eval {
	# load required files
	require 'uig.cfg';
	push(@INC, "$ScriptPath");
	require $ScriptPath.$slash."uiglib.cgi";
	require $ScriptPath.$slash."memory.cgi";
	require $ScriptPath.$slash."display.cgi";
};
if ($@) {
	print qq~
	Content-type: text/html\n\n
	<b><font face="Verdana, Arial">Error including the required files:<blockquote>~;
    print "$@\n\n";
	exit;	
}

use CGI;
$cgi = new CGI;
#eval use_named_parameters to work with both old and new versions of CGI.pm
eval '$cgi->use_named_parameters';

#read cookie
$CookieData = $cgi->cookie("$CookieName");
if ($CookieData){
	CrumbleCookie();
}
InitFromParameters();
LoadProfile();
if($cgi->param("func") eq "showlogin") {
	ShowLogin();
} elsif($cgi->param("func") eq "login") {
	my $rval = Login();
	if($rval eq "true") {
		WriteMessage("Welcome back $Username, you have been logged in.");
	} elsif($rval eq "false") {
		ShowLogin("You entered an incorrect password.");
	} 
} elsif($cgi->param("func") eq "logout") {
	Logout();
} elsif($cgi->param("func") eq "showregister") {
	ShowRegister();
} elsif($cgi->param("func") eq "register") {
	Register();
} elsif($cgi->param("func") eq "setsort") {
	$SortBy = $cgi->param("sort");
	SetCookie(PrepareCookie());
} elsif($cgi->param("func") eq "showsort") {
	ShowSortOptions();
} elsif($cgi->param("func") eq "search") {
	if($cgi->param("searchterm")) {
		require $ScriptPath.$slash."categories.cgi";
		require $ScriptPath.$slash."media.cgi";
		#initialize media 
		ReadCategories();
		$searchterm = DecodeURL($cgi->param("searchterm"));
		ReadMedia($cgi->param("Category"), $searchterm, $cgi->param("searchfield"));
		if(!@MediaList) {
			
			FatalError(qq~Found 0 Results for '$searchterm'~);
		}
		ShowGallery();
	} else {
		ShowSearchForm();
	}
} elsif($cgi->param("func") eq "showupload") {
	require $ScriptPath.$slash."categories.cgi";
	require $ScriptPath.$slash."media.cgi";
	#initialize media 
	ReadCategories();
	$CategoryPath = $MediaPath.$CategoryList[$CategoryIndex]->{PATH}."imagedata.cgi";
	$CategoryPath = $MediaPath.$CategoryPath;
	$Category = $CategoryList[$CategoryIndex]->{NAME};
	ShowUpload();
} elsif($cgi->param("func") eq "upload") {
	require $ScriptPath.$slash."categories.cgi";
	require $ScriptPath.$slash."media.cgi";
	require $ScriptPath.$slash."plugins.cgi";
	if(!$Username || $Username eq "Guest") {
		Login();
	}
	ReadCategories();
	ReadMedia($CategoryIndex);
	$CategoryPath = $MediaPath.$CategoryPath;
	$Category = $CategoryList[$CategoryIndex]->{NAME};
	LoadPlugins();
	Upload();
}

if($cgi->param("func") eq "show") {
	require $ScriptPath.$slash."categories.cgi";
	require $ScriptPath.$slash."media.cgi";
	ReadCategories();
	$Category = $CategoryList[$CategoryIndex]->{NAME};
	$granted = "false";
	if($CategoryList[$CategoryIndex]->{PROTECTED} eq "true") {
		if(($CategoryList[$CategoryIndex]->{GROUPS} =~ /$UserProfile[16]/ && $UserProfile[16] ne "" && $Username ne "") ||
			($CategoryList[$CategoryIndex]->{USERS} =~ /$Username/ && $Username ne "")) {
			$granted = "true";
		}
	} else {
		$granted = "true";
	}
	if($granted eq "true") {
		ShowMedia();		
	} else {
		if($Username eq "" || $LoggedIn eq "false") {
			ShowLogin("This is a restricted category, please login first.");
		}
		FatalError("You do not have permission to access this category.<p>");
	}
} elsif($CategoryIndex < 0) {
	require $ScriptPath.$slash."categories.cgi";
	ReadCategories();
	ShowCategoryListing();
} else {
	#Category is set and nothing else needs to be done so show gallery
	require $ScriptPath.$slash."categories.cgi";
	require $ScriptPath.$slash."media.cgi";
	#initialize media 
	ReadCategories();
	$Category = $CategoryList[$CategoryIndex]->{NAME};
	$granted = "false";
	if($CategoryList[$CategoryIndex]->{PROTECTED} eq "true") {
		if(($CategoryList[$CategoryIndex]->{GROUPS} =~ /$UserProfile[16]/ && $UserProfile[16] ne "" && $Username ne "") ||
			($CategoryList[$CategoryIndex]->{USERS} =~ /$Username/ && $Username ne "")) {
			$granted = "true";
		}
	} else {
		$granted = "true";
	}
	if($granted eq "true") {
		ReadMedia($CategoryIndex);
		$CategoryPath = $MediaPath.$CategoryPath;
		ShowGallery();
	} else {
		if($Username eq "" || $LoggedIn eq "false") {
			ShowLogin("This is a restricted category, please login first.");
		}
		FatalError("You do not have permission to access this category.<p>");
	}
}

########################################################################################

sub InitFromParameters
{
	if($SortBy ne "") {
		
	} elsif($cgi->param("selectedsort") ne "") {
		$SortBy = $cgi->param("selectedsort");
	} elsif($cgi->param("sort") ne "") {
		$SortBy = $cgi->param("sort");
	} else {
		$SortBy = $DefaultSort;
	}
	if($cgi->param("Page") ne "") {
		$Page = $cgi->param("Page");
	} else {
		$Page = 1;
	}	
	if($cgi->param("Category") ne "") {
		$CategoryIndex = int($cgi->param("Category"));
		if($CategoryIndex < 0) { $Category = "NONE"; }
	} else {
		$CategoryIndex = -1;
		$Category = "NONE";
	}
}

########################################################################################

sub CategoryTree {
	if($cgi->param("searchterm")) { return; }
	if(!@CatTree) { BuildCatTree($cgi->param("Category")); }
	my($html) = qq~
	<!-- CategoryTree -->
    <table border="0" class="CatTreeNavStyle">
      <tr>
        <td width="100%"><font color="$FontColor" face="$FontFace" size="1" class="CatTreeNavStyle">
	     <img border="0" src="$SkinUrl/open.gif" width="15" height="11">
		  <a href="$GalleryUrl/$GalleryCgi">$GalleryTitle</a></font><br>
	~;
	for(my($counter) = 0; $counter < @CatTree; $counter++) {
		for(my($index) = 0; $index < $CatTree[$counter]->{DEPTH}; $index++) {
			$html = $html."&nbsp;&nbsp;";
		}
		if($CatTree[$counter]->{INDEX} == $cgi->param("Category")) { 
			$html = $html.qq~
		      <img border="0" src="$SkinUrl/tline.gif" width="12" height="12"><img border="0" src="$SkinUrl/open.gif" width="15" height="11"><font color="$FontColor" face="$FontFace" size="1" class="CatTreeNavStyle">
			  $CatTree[$counter]->{NAME}<br>
			~;
		} else {
			$html = $html.qq~
		      <img border="0" src="$SkinUrl/tline.gif" width="12" height="12"><img border="0" src="$SkinUrl/open.gif" width="15" height="11"><font color="$FontColor" face="$FontFace" size="1" class="CatTreeNavStyle">
			  <a href="$GalleryUrl/$GalleryCgi?Category=$CatTree[$counter]->{INDEX}">$CatTree[$counter]->{NAME}</a><br></font>
			~;
		}

	}
	$html = $html.qq~
		</td>
      </tr>
    </table>
	<!-- End CategoryTree -->
	~;

	return $html;
}

sub SubCategoryList {
	if($cgi->param("searchterm")) { return; }
	if(!@SubCats) { FindSubCategories(); }
	my($html) = qq~
	<!-- SubCategoryList -->
	<table border="0" cellpadding="2" cellspacing="1" width="100%"><tr><td colspan="2"><font color="$FontColor" face="$FontFace" size="$FontSize" class="SubCatListStyle">
	Sub Categories:</font></td></tr>
	~;
	for($counter = 0; $counter < @SubCats; $counter++) {
		if($counter % 2 == 0) {
			$html = $html.qq~<tr>~;
		}
		if($SubCats[$counter]->{IMAGE} ne "") {
			$catimg = qq~<a href="$GalleryUrl/$GalleryCgi?Category=$SubCats[$counter]->{INDEX}">
						<img border="0" src="$SkinUrl/$SubCats[$counter]->{IMAGE}"></a>~;
		} else {
			$catimg = "";
		}
		$html = $html.qq~
		<!--<td><img src="$SkinUrl/blank.gif" height=1 width=10></td>-->
		<td align="left" width="50%" valign="top">
		<table border="0" cellpadding="0" cellspacing="0">
		<tr><td valign="top">
		<font color="$FontColor" face="$FontFace" size="$FontSize" class="SubCatListStyle">
		$catimg
		</font>
		</td>
		<td valign="top">
		<font color="$FontColor" face="$FontFace" size="$FontSize" class="SubCatListStyle">
		<a href="$GalleryUrl/$GalleryCgi?Category=$SubCats[$counter]->{INDEX}">		
		$SubCats[$counter]->{NAME}</a><br>
		$SubCats[$counter]->{DESC}<br><small>($SubCats[$counter]->{SUBS} Sub-Categories, $SubCats[$counter]->{COUNT} Images)</small>
		</font></td></tr>
		</table>
		</td>
		~;
		if($counter == @SubCats - 1 && @SubCats % 2 == 1) {
			$html = $html.qq~<td width="50%">&nbsp;</td>~;
		}
		if($counter % 2 == 1) {
			$html = $html.qq~</tr>~;
		}
	}
	$html = $html.qq~
	</tr></table>
	<!-- EndSubCategoryList -->
	~;
	return $html;
}

########################################################################################

sub PageStats {
	if($cgi->param("func") eq "show") { return; }
	if($TotalPages == 0) {
		$PageStats = "$NumPictures entries<br>Page $Page of 1";
	} else {
		$PageStats = "$NumPictures entries<br>Page $Page of $TotalPages";
	}
	my($html);
	$html = qq~
	<!-- PageStats -->
	<font color="$FontColor" face="$FontFace" size="$FontSize" class="PageStatsStyle">
	$PageStats</font>
	<!-- End PageStats -->
	~;
	return $html;
}

########################################################################################

sub CategoryInline {
	my $filename = shift;
	if($cgi->param("searchterm") ne "") { 
		$SearchDisplay = "Search Results for '".$cgi->param("searchterm")."'";
	} elsif(!@CatInline) { 
		BuildCatInline($cgi->param("Category")); 
	}
	my($html) = qq~
	<!-- CategoryInline -->
	<table border="0" cellpadding="2" cellspacing="1" width="100%"><tr><td>
	<p><font color="$FontColor" face="$FontFace" size="$FontSize" class="CatInlineNavStyle"><a href="$GalleryUrl/$GalleryCgi">Top</a>
	~;
	if($SearchDisplay) {
		$html = $html."> $SearchDisplay";
	} else {
		for(my($counter) = 0; $counter < @CatInline; $counter++) {
			if(($filename eq "" && $CatInline[$counter]->{INDEX} == $cgi->param("Category")) || $CatInline[$counter] eq "Search Results") { 
				$html = $html."> $CatInline[$counter]->{NAME} ";
			} else {
				$html = $html.qq~> <a href="$GalleryUrl/$GalleryCgi?Category=$CatInline[$counter]->{INDEX}">$CatInline[$counter]->{NAME}</a> ~;
			}
		}
		if($filename) {
			$html = $html.qq~ > $filename~;
		}
	}
	$html = $html.qq~
	</font></p>
	</td></tr></table>
	<!-- End CategoryInline -->
	~;
	return $html;
}

########################################################################################

sub SortDropBox {
	my($html) = qq~<!-- SortDropBox --><form METHOD="POST" ACTION="$GalleryCgi">
	<input type="HIDDEN" name="Category" value="$CategoryIndex">
	<font color="$FontColor" face="$FontFace" size="$FontSize">Sort images by:</font>
       <select class="SortListBoxStyle" name="selectedsort">
         <option selected value="filename">Filename</option>
         <option value="downloads">Downloads</option>
         <option value="date">Date</option>
         <option value="author">Author</option>
       </select>  
	<input class="SortInputStyle" type="submit" value="Sort!">
	</form><!-- End SortDropBox -->~;
	return $html;
}

########################################################################################

sub CategoryDropBox {
	if(!@CategoryList) {
		require $ScriptPath.$slash."categories.cgi";
		ReadCategories();
	}
	my($html) = qq~<!-- CategoryDropBox --><form METHOD="POST" ACTION="$GalleryCgi">
	<font color="$FontColor" face="$FontFace" size="$FontSize"><br>
	Jump To: </font><select name="Category" class="CatListBoxStyle">
	~;
	for(my($counter) = 0; $counter < @CategoryList; $counter++) {
		$html = $html.qq~ <option value="$CategoryList[$counter]->{INDEX}"> ~;
		for(my($num) = 0; $num < @CategoryList[$counter]->{DEPTH}; $num++) {
			#if($num == (scalar($CategoryList[$counter]->{DEPTH}) - 1)) {
			#	print "|--";
			#} else {
				$html = $html."&nbsp;&nbsp;&nbsp;";
			#}
		}
		$html = $html.qq~$CategoryList[$counter]->{NAME}</option> ~;
	}
	$html = $html.qq~
	</select>&nbsp;<input class="CatInputStyle" type="submit" value="Go!">
    </font></form><!-- End CategoryDropBox -->~;
	return $html;
}

########################################################################################

sub SearchBox {
	my($html) = qq~
	<!-- SearchBox -->
	<form method="POST" action="$GalleryCgi">
	<input type="hidden" name="func" value="search">
	<input type="hidden" name="Category" value="$CategoryIndex">
	<font color="$FontColor" face="$FontFace" size="$FontSize">
	Search: <input type="input" name="searchterm" size="20" class="SearchBoxStyle">
	<input type="submit" name="search" value="Go!" class="SearchBoxStyle"></font></form>
	<!-- EndSearchBox -->
	~;
	return $html;
}

########################################################################################



########################################################################################

sub NavBack {
	my($html) = qq~
	<!-- NavBack -->
	<p align="center"><strong><font face="$FontFace" color="$FontColor" size="$FontSize">Go Back to <a href="$SiteUrl">$SiteTitle</a></font></strong></p>
	<!-- End NavBack -->
	~;
}

########################################################################################

sub PageNavigation {
	my($prev, $next, $html);
	$prev = $CategoryIndex - 1;
	if($CategoryIndex == @CategoryList - 1) {
		$next = 0;
	} else {
		$next = $CategoryIndex + 1;
	}
	my $PageNav = qq~<table border="0" width="100%" class="PageNavStyle"><tr> ~;
	if($cgi->param("searchterm") eq "") {
		$PageNav = $PageNav.qq~ <td width="33%" align="left"><font face="$FontFace" size="$FontSize" class="PageNavStyle">Prev $CategoryName<br>
		<a href="$GalleryUrl/$GalleryCgi?Category=$prev">$CategoryList[$prev]->{NAME}</a></font></td> ~;
		$width = "33%";
	} else {
		$width = "100%";
	}

	$PageNav = $PageNav.qq(<td width="$width" align="center"><font face="$FontFace" size="$FontSize" class="PageNavStyle">Jump To Page:<br>);
	if($Page > 1 && $TotalPages > 1) {
		$PageNav = $PageNav."<a href=\"$GalleryUrl/$GalleryCgi?Category=".$CategoryIndex."&Page=".($Page - 1)."\">&lt;&lt;</a> ";
	}
	if($Page < 1) {
		$PageNav = $PageNav."No Pages Exist!";
	}
	for($j = 1; $j <= $TotalPages; $j++) {
		if($j == $Page) {
			$PageNav = $PageNav."[".$j."]";
		} else {
			$PageNav = $PageNav."<a href=\"$GalleryUrl/$GalleryCgi?Category=".$CategoryIndex."&Page=".($j)."\">[".$j."]</a>";
		}
	}
	if($Page < $TotalPages) {
		$PageNav = $PageNav." <a href=\"$GalleryUrl/$GalleryCgi?Category=".$CategoryIndex."&Page=".($Page + 1)."\">&gt;&gt;</a>";
	}
	$PageNav = $PageNav."</td>";
	if($cgi->param("searchterm") eq "") {
		$PageNav = $PageNav.qq~ <td width="33%" align="right"><font face="$FontFace" size="$FontSize" class="PageNavStyle">Next $CategoryName<br>
		<a href="$GalleryUrl/$GalleryCgi?Category=$next">$CategoryList[$next]->{NAME}</a></font></td>~;
	}
	$PageNav = $PageNav."</tr></table>";
	$html = qq~
	<!-- PageNavigation -->
	<font color="$FontColor" face="$FontFace" size="$FontSize" class="PageNavStyle">
	$PageNav</font>
	<!-- End PageNavigation -->
	~;
	return $html;
}

sub ShowNavigation {
	$prev = $MediaIndex - 1;
	if($MediaIndex == @MediaList - 1) {
		$next = 0;
	} else {
		$next = $MediaIndex + 1;
	}
	my $PageNav = qq~<table border="0" width="100%" class="PageNavStyle"><tr> ~;
	$PageNav = $PageNav.qq~ <td width="33%" align="left"><font face="$FontFace" size="$FontSize" class="PageNavStyle">Previous<br>
	<a href="$GalleryUrl/$GalleryCgi?func=show&file=$MediaList[$prev][$FILENAME]&Category=$CategoryIndex&Page=$Page">$MediaList[$prev][$FILENAME]</a></font></td> ~;

	$PageNav = $PageNav.qq(<td width="33%" align="center"><font face="$FontFace" size="$FontSize" class="PageNavStyle">
	<a href="$GalleryUrl/$GalleryCgi?Category=$CategoryIndex&Page=$Page">Thumbnails</a></td>);

	$PageNav = $PageNav.qq~ <td width="33%" align="right"><font face="$FontFace" size="$FontSize" class="PageNavStyle">Next<br>
	<a href="$GalleryUrl/$GalleryCgi?func=show&file=$MediaList[$next][$FILENAME]&Category=$CategoryIndex&Page=$Page">$MediaList[$next][$FILENAME]</a></font></td>~;
	
	$PageNav = $PageNav."</tr></table>";
	$html = qq~
	<!-- PageNavigation -->
	<font color="$FontColor" face="$FontFace" size="$FontSize" class="PageNavStyle">
	$PageNav</font>
	<!-- End PageNavigation -->
	~;
	return $html;

}

########################################################################################

sub MediaField {
	my($index) = shift;
	my($field) = shift;

	return $MediaList[$index][$field];
}

########################################################################################

sub CategoryTable {
	my($html);
	$html = qq~
	<!-- CategoryTableHtml -->
	<table border="0" width="100%">
    <tr>
      <td width="100%"><font face="$FontFace" size="$FontSize" color="$FontColor">$CategoryName Listing:</font></td>
    </tr>
	</table>
	<center>
	<table border="0" width="90%">
	~;
	if(@CategoryList == 0) {
		$html = $html.qq~
		<tr>
		  <td width="100%" align="center">
		  <font face="$FontFace" size="$FontSize" color="$FontColor">Sorry, no categories exist yet.
		  </td>
		</tr>
		~;
	}
	my($catcount) = 0;
	for($counter = 0; $counter < @CategoryList; $counter++) {
		if($CategoryList[$counter]->{DEPTH} == 0 && $CategoryList[$counter]->{VISIBLE} eq "true" && GoodStartDate($CategoryList[$counter]->{STARTDATE}) && GoodEndDate($CategoryList[$counter]->{ENDDATE})) {
			if($catcount % 2 == 0) {
				$html = $html."<tr>";
			}
			$html = $html."<td width=\"50%\">";
			if($CategoryList[$counter]->{IMAGE} ne "") {
				$catimg = qq~<img border="0" src="$SkinUrl/$CategoryList[$counter]->{IMAGE}">~;
			} else {
				$catimg = "";
			}
			$html = $html.qq~ <font face="$FontFace" size="$FontSize" color="$FontColor">
			<big><b><a href="$GalleryUrl/$GalleryCgi?Category=$counter">
			$catimg $CategoryList[$counter]->{NAME}</a></b></big><br>
			<table border="0" cellpadding="0" cellspacing="0">
			<tr><td>
			<img src="$SkinUrl/blank.gif" height=1 width=30>
			</td>
			<td>
			<small>$CategoryList[$counter]->{DESC}<br>($CategoryList[$counter]->{SUBS} Sub-Categories, $CategoryList[$counter]->{COUNT} Images)</small></font>
			</td>
			</tr>
			</table>
			~;
			$html = $html."</td>";
			if($catcount % 2 == 1){
				$html = $html."</tr>";
			}	
			$catcount++;
		}
	}
	$html = $html.qq~
	</table>
	<!-- End CategoryTableHtml -->
	~;
	return $html;
}

sub ThumbTable {
	my($html);
	if($NumPictures == 0) {
		if(!@SubCats) { FindSubCategories(); }
		if(!@SubCats) {
			$html = qq(<table border="0" cellpadding="0" cellspacing="0" bgcolor="$TableBodyColor" width="100%" class="ThumbTable"><tr>\n);
			$html = $html.qq(<td bgcolor="$TableBodyColor" align="center"><p><font face='$FontFace' color='$FontColor' size=$FontSize>No pictures available</font></p></td>);
			$html = $html.qq(</tr></table>);
		}
	} else {
		$start = $Index;
		$width = 100 / $PageColumns;
		$maxindex = $PicsOnPage + $Index;
		my($counter);
		my($stop) = 0;
		$html = $html.qq(<table border="0" cellpadding="0" cellspacing="0" bgcolor="$TableBodyColor" width="100%" class="ThumbTableStyle">);
		for($rowcounter = 0, $imgcount = 0; $rowcounter < $PageRows; $rowcounter++) {
			if($imgcount >= $PicsOnPage) {
				last;
			}
			$html = $html.qq(<tr>\n);
			for($colcounter = 0; $colcounter < $PageColumns; $colcounter++, $imgcount++, $Index++) {
				if($imgcount >= $PicsOnPage) {
					#stop trying to print images, fill the remaining columns, then get the fuck outta here.
					$html = $html.qq(\n<td bgcolor="$TableBodyColor" align="center" valign="middle" width="$width%" class="ThumbTableTDStyle">);
					$html = $html.qq(<table border=0><tr><td align="center">&nbsp;);
					$html = $html.qq(</td></tr><tr><td valign="bottom">);
					$html = $html.qq(</td></tr></table>);
					$html = $html.qq(</td>\n);	
					$stop = 1;
				} else {
					$html = $html.qq(\n<td bgcolor="$TableBodyColor" align="center" valign="center" width="$width%" class="ThumbTableTDStyle">\n);
					$html = $html.ThumbHTML($Index);				
					$html = $html.qq(</td>\n);
				}
			}
			$html = $html.qq(</tr>\n);
			if($stop == 1) {
				last;
			}
		}
		$html = $html.qq(</table>\n);
	}	
	return $html;
}

########################################################################################

sub ThumbHTML {
	my($index) = shift;
	if($MediaList[$index][$FILENAME] eq "") {
		return "";
	}
	if ($MediaList[$index][$THUMBNAME] eq "NODATA") {
		#the thumbname is not present, check using prefix and filename
		$imagesrc = $MediaPath.$CategoryList[$MediaList[$index][$CATINDEX]]->{PATH}."thumbs$slash".$thumbprefix.$MediaList[$index][$FILENAME];
		if (-e "$imagesrc") {
			#thumb exists
			$imagesrc = $MediaUrl.$CategoryList[$MediaList[$index][$CATINDEX]]->{PATH}."thumbs/".$thumbprefix.$MediaList[$index][$FILENAME];
		} else {
			#does not exist, use a default
			$imagesrc = $SkinUrl."/notfound.gif";
		}
	} else {
		#thumb is present see if exists in dir
		$imagesrc = $MediaPath.$CategoryList[$MediaList[$index][$CATINDEX]]->{PATH}."thumbs$slash".$MediaList[$index][$THUMBNAME];
		if (-e "$imagesrc") {
			#thumb exists
			$imagesrc = $MediaUrl.$CategoryList[$MediaList[$index][$CATINDEX]]->{PATH}."thumbs/".$MediaList[$index][$THUMBNAME];
		} else {
			#does not exist, use a default
			$imagesrc = $SkinUrl."/notfound.gif";
		}
	}
	ReadFileTypes();
	$OpenFileIn = $FileOpen{$MediaList[$index][$TYPE]};
	if($OpenFileIn eq "samewindow") {
		$link = qq~
		<a href=$GalleryCgi?func=show&file=$MediaList[$index][$FILENAME]&Category=$MediaList[$index][$CATINDEX]&Page=$Page>
		<img src=\"$imagesrc\" border=$border hspace=5 vspace=5></a>
		~;
	} elsif($OpenFileIn eq "newwindow") {
		$link = qq~
		<a href=$GalleryCgi?func=show&file=$MediaList[$index][$FILENAME]&Category=$MediaList[$index][$CATINDEX]&Page=$Page target="_new">
		<img src=\"$imagesrc\" border=$border hspace=5 vspace=5></a>
		~;
	} elsif($OpenFileIn eq "download") {
		$MediaLink = $MediaUrl.$CategoryList[$MediaList[$index][$CATINDEX]]->{PATH}."/media/".$MediaList[$index][$FILENAME];
		$link = qq~
		<a href=$MediaLink target="_new">
		<img src=\"$imagesrc\" border=$border hspace=5 vspace=5></a>
		~;		
	} else {
		$link = qq~
		<a href=$GalleryCgi?func=show&file=$MediaList[$index][$FILENAME]&Category=$MediaList[$index][$CATINDEX]&Page=$Page>
		<img src=\"$imagesrc\" border=$border hspace=5 vspace=5></a>
		~;
	}
	$ThumbDisplayFormat = "\n<!-- ThumbHTML $index -->\n".$ThumbDisplay;

	if($MediaList[$index][$FILENAME] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!FILENAME>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$FILENAME]/g;
	}
	if($MediaList[$index][$TYPE] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!TYPE>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$TYPE]/g;
	}
	if($MediaList[$index][$DATE] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!DATE>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$DATE]/g;
	}
	if($MediaList[$index][$COPYRIGHT] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!COPYRIGHT>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$COPYRIGHT]/g;
	}
	if($MediaList[$index][$AUTHOR] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!AUTHOR>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$AUTHOR]/g;
	}
	if($MediaList[$index][$DOWNLOADS] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!DOWNLOADS>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$DOWNLOADS]/g;				
	}
	if($MediaList[$index][$DESCRIPTION] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!DESCRIPTION>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$DESCRIPTION]/g;
	}
	if($MediaList[$index][$USER] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!USER>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$USER]/g;
	}
	if($MediaList[$index][$IP] ne "NODATA") {
		$ThumbDisplayFormat =~ s/<!IP>/<font face='$FontFace' size='$FontSize' color='$FontColor' class="ThumbInfoStyle">$MediaList[$index][$IP]/g;
	}
	$ThumbDisplayFormat =~ s/<!THUMBNAIL>/$link/g;
	return $ThumbDisplayFormat."\n<!-- End ThumbHTML $index -->\n";
}

########################################################################################

sub FullsizeHtml {
	
	$baseimglink = "$MediaUrl$CategoryList[$CategoryIndex]->{PATH}media$slash$ShowData[$FILENAME]";

	ReadFileTypes();
	if($FileCode{"$ShowData[$TYPE]"} ne "") {
		$code = $FileCode{"$ShowData[$TYPE]"};
	} else {
		$code = $FileCode{"Image/GIF"};
	}
	$code =~ s/<!FILENAME>/$baseimglink/g;
	$ImageDisplayFormat = qq(<table border="0" cellpadding="0" cellspacing="0" width="100%" bgcolor="$TableBodyColor" class="ThumbTable"><tr>\n<td align="center">);
	$ImageDisplayFormat = $ImageDisplayFormat.$ImageDisplay;
	$ImageDisplayFormat =~ s/<!FULLSIZE>/$code/g;
	$ImageDisplayFormat =~ s/<!FILENAME>/$ShowData[$FILENAME]/g;
	#$ImageDisplayFormat =~ s/<!FILESIZE>/$
	$ImageDisplayFormat =~ s/<!TYPE>/$ShowData[$TYPE]/g;
	if($ShowData[$DATE] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!DATE>/$ShowData[$DATE]/g;
	}
	if($ShowData[$COPYRIGHT] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!COPYRIGHT>/$ShowData[$COPYRIGHT]/g;
	}
	if($ShowData[$AUTHOR] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!AUTHOR>/$ShowData[$AUTHOR]/g;
	}
	$ImageDisplayFormat =~ s/<!DOWNLOADS>/$ShowData[$DOWNLOADS]/g;				
	if($ShowData[$DESCRIPTION] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!DESCRIPTION>/$ShowData[$DESCRIPTION]/g;
	}
	if($ShowData[$USER] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!USER>/$ShowData[$USER]/g;
	}
	if($ShowData[$IP] ne "NODATA") {
		$ImageDisplayFormat =~ s/<!IP>/$ShowData[$IP]/g;
	}
	$ImageDisplayFormat = $ImageDisplayFormat.qq(</td></tr></table>);
	return $ImageDisplayFormat;
}

