##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# categories.cgi

sub BuildCatData {
	my($CurDirectory) = $MediaPath;
	#WriteMessage("Beginning search of Categories at $CurDirectory\n");
	chdir($MediaPath);
	@CategoryList = ();
	$CatCounter = 0;
	$Depth = 0;
	TraverseDir($CurDirectory);

	#for($counter = 0; $counter < @CategoryList; $counter++) {
	#	print "<p><b>$counter:<br>";
	#	print "PATH: $CategoryList[$counter]->{PATH}<br>";
	#	print "NAME: $CategoryList[$counter]->{NAME}<br>";
	#	print "COUNT: $CategoryList[$counter]->{COUNT}<br>";
	#	print "DESC: $CategoryList[$counter]->{DESC}<br>";
	#	print "IMAGE: $CategoryList[$counter]->{IMAGE}<br>";
	#	print "VISIBLE: $CategoryList[$counter]->{VISIBLE}<br>";
	#	print "PROTECTED: $CategoryList[$counter]->{PROTECTED}<br>";
	#	print "STARTDATE: $CategoryList[$counter]->{STARTDATE}<br>";
	#	print "ENDDATE: $CategoryList[$counter]->{ENDDATE}<br>";
	#	print "USESKIN: $CategoryList[$counter]->{USESKIN}<br>";
	#	print "SKIN: $CategoryList[$counter]->{SKIN}<br>";
	#	print "GROUP: $CategoryList[$counter]->{GROUP}<br>";
	#	print "USERS: $CategoryList[$counter]->{USERS}<br>";
	#	print "LASTMODIFIED: $CategoryList[$counter]->{LASTMODIFIED}<br>";
	#}
	#WriteMessage("Writing to file $MediaPath/allcategories.cgi.");
	CalcSubs();
	CalcTotalDownloads();
	WriteCategories();
	if($DisregardOrder eq "true") {
		WriteMessage("Built all Categories from scratch.");
	} else {
		WriteMessage("Built all Categories.");
	}
}

sub WriteCategories {
	$fh = OpenFile($MediaPath.$slash."allcategories.cgi", "write");
	for($counter = 0; $counter < @CategoryList; $counter++) {
		print $fh "$CategoryList[$counter]->{PATH}\|".
					"$CategoryList[$counter]->{DEPTH}\|".
					"$CategoryList[$counter]->{NAME}\|".
					"$CategoryList[$counter]->{COUNT}\|".
					"$CategoryList[$counter]->{SUBS}\|".
					"$CategoryList[$counter]->{DOWNLOADS}\|".
					"$CategoryList[$counter]->{DESC}\|".
					"$CategoryList[$counter]->{IMAGE}\|".
					"$CategoryList[$counter]->{VISIBLE}\|".
					"$CategoryList[$counter]->{PROTECTED}\|".
					"$CategoryList[$counter]->{STARTDATE}\|".
					"$CategoryList[$counter]->{ENDDATE}|".
					"$CategoryList[$counter]->{USESKIN}\|".
					"$CategoryList[$counter]->{SKIN}\|".
					"$CategoryList[$counter]->{GROUPS}\|".
					"$CategoryList[$counter]->{USERS}\|".
					"$CategoryList[$counter]->{LASTMODIFIED}\n";
	}
	CloseFile(\*$fh);
	chmod(0666, $MediaPath.$slash."allcategories.cgi"); 
}

sub CalcSubs {
	for(my $counter = 0; $counter < @CategoryList; $counter++) {
		my $CurDirectory = $MediaPath.$CategoryList[$counter]->{PATH};
		opendir(DIR, $CurDirectory) or FatalError("Unable to open directory $CurDirectory for reading!<br>Reason: $!");
		my(@tempentries) = grep(!/^\.\.?$/, readdir (DIR)); 
		closedir(DIR);	
		my $subcount = 0;
		foreach $tempentry (@tempentries) {
			if((-d $CurDirectory.$tempentry) && $tempentry ne "media" && $tempentry ne "thumbs") {
				$subcount++;
			}			
		}
		$CategoryList[$counter]->{SUBS} = $subcount;
		$file = $CurDirectory."categorydata.cgi";
		if(-e $file) {
			$fh = OpenFile($file, "read");
			@CatData = <$fh>;
			CloseFile(\*$fh);
		} else {
			$CatData[0] = "\n";
			$CatData[1] = "\n";
		}
		$CatData[2] = $subcount."\n";
		$fh = OpenFile($file, "write");
		foreach $data (@CatData) {
			print $fh $data;
		}
		CloseFile(\*$fh);
	}
}

sub CalcTotalDownloads {
	for(my $counter = 0; $counter < @CategoryList; $counter++){
		ReadMedia($counter);
		my $total = 0;
		for(my $mediacount = 0; $mediacount < @MediaList; $mediacount++) {
			$total = $total + $MediaList[$mediacount][$DOWNLOADS];
		}
		$CategoryList[$counter]->{DOWNLOADS} = $total;
	}
}

sub TraverseDir {
	my($CurDirectory) = shift;
	#WriteMessage("Traversing Directory: $CurDirectory");
	my(@DirEntries);	
	if(!(-e $CurDirectory.$slash."categoryorder.cgi") || $DisregardOrder eq "true") {
	#This section of code below needs to be used if categoryorder.cgi does not exist.
		opendir(DIR, $CurDirectory) or FatalError("Unable to open directory $CurDirectory for reading!<br>Reason: $!");
		my(@tempentries) = grep(!/^\.\.?$/, readdir (DIR)); 
		closedir(DIR);
		#get rid of directories that aren't categories...
		foreach $temp (@tempentries) {
			#WriteMessage("Found directory entry: $temp");
			if($temp ne "media" && $temp ne "thumbs") {
				push(@DirEntries, $temp);
			}			
		}
	} else {
		$fh = OpenFile($CurDirectory.$slash."categoryorder.cgi", "read");
		my $linecount = 0;
		while(<$fh>) {
			$line = $_;
			chomp($line);
			@temp = split(/\|/, $line);
			$temp[0] =~ s/^$slash//g;
			$temp[0] =~ s/$slash$//g;
			$DirEntries[$linecount] = $temp[0];
			$linecount++;
			#push(@DirEntries, $line);
		}
		CloseFile(\*$fh);
	}
	#foreach $entry (@DirEntries) {
	#	WriteMessage("Found entry in $CurDirectory/categoryorder.cgi of $entry");
	#}
	#foreach $entry (@DirEntries) {
	#	if(-d ("$CurDirectory/$entry")) {
	#		WriteMessage("Incrementing $CategoryList[$CatCounter]->{NAME}.");
	#		$CategoryList[$CatCounter]->{SUBS}++;	
	#	}
	#}
	foreach $entry (@DirEntries) {
		#WriteMessage("Entry is '$entry'");
		if(-d ($CurDirectory.$slash."$entry")) {
			#WriteMessage("Working on $CurDirectory$slash$entry");
			my(@catdata) = ReadCatInfo("$CurDirectory$slash$entry");
			if($CatCounter > 0) {
				$CategoryList[($CatCounter - 1)]->{SUBS}++;
			}
				
			#print "<p><b>CatData: ";
			#foreach $cat (@catdata) {
			#	print "$cat | ";
			#}
			#print "<p>";
			my($temppath) = "$CurDirectory$slash$entry$slash";
			#Warning!!
			#We must strip out the root media path from the new entry, however...
			#If this script is on NT and we are using slash == '\\', we must regexp the '\' in $MediaPath to '\\'
			#This more than likely will never create a problem.  But I'm not 100% sure.
			$StripPath = $MediaPath;
			$StripPath =~ s/\\/\\\\/g;
			$temppath =~ s/$StripPath//g;
			$name = $catdata[0];
			if($name eq "") {
				$name = $entry;
			}
			my($record) = {
				PATH		=> $temppath,
				DEPTH		=> $Depth,
				NAME		=> $name,
				COUNT		=> $catdata[1],
				SUBS		=> $catdata[2],
				DOWNLOADS	=> $catdata[3],
				DESC		=> $catdata[4],
				IMAGE		=> $catdata[5],
				VISIBLE		=> $catdata[6],
				PROTECTED	=> $catdata[7],
				STARTDATE	=> $catdata[8],
				ENDDATE		=> $catdata[9],
				USESKIN		=> $catdata[10],
				SKIN		=> $catdata[11],
				GROUPS		=> $catdata[12],
				USERS		=> $catdata[13],
				LASTMODIFIED=> $catdata[14],
				INDEX		=> $CatCounter
			};
			$CategoryList[$CatCounter] = $record;
			$CatCounter++;
			$Depth++;
			#WriteMessage("Traversing...");
			TraverseDir("$CurDirectory$slash$entry");			 
		}# else {
		#	WriteMessage("$CurDirectory$slash$entry was not a directory!");
		#}
	}
	if($Depth > 0) {
		$Depth--;
	}
}

sub ReadCatInfo {
	my($CatPath) = shift;
	#WriteMessage("Reading cat info on $CatPath/categorydata.cgi");
	if(!(-e $CatPath.$slash."categorydata.cgi")) {
		$name = GetFileName($CatPath);
		$fh = OpenFile($CatPath.$slash."categorydata.cgi", "write");	
		print $fh "$name\n";
		print $fh "0\n";					#image count
		print $fh "0\n";					#sub category count
		print $fh "0\n";					#image downloads #not filled every time categories are read
		print $fh "\n";
		print $fh "categoryfolder.gif\n";	#category icon
		print $fh "true\n";					#Visible
		print $fh "false\n";				#protected
		print $fh "\n";
		print $fh "\n";
		print $fh "\n";
		print $fh "\n";
		print $fh "\n";
		print $fh "\n";
		print $fh "\n";
		CloseFile(\*$fh);
		chmod(0666, $CatPath.$slash."categorydata.cgi");
	}
	$fh = OpenFile($CatPath.$slash."categorydata.cgi", "read");
	my(@catdata) = <$fh>;
	CloseFile(\*$fh);
	foreach $cat (@catdata) {
		$cat =~ s/\n//g;
	}
	#WriteMessage("ReadCatInfo Done.");
	return @catdata;	
}

sub WriteCatInfo {
	my $catindex = shift;
	$fh = OpenFile("$MediaPath$CategoryList[$catindex]->{PATH}categorydata.cgi", "write");	
	print $fh "$CategoryList[$catindex]->{NAME}\n";
	print $fh "$CategoryList[$catindex]->{COUNT}\n";					#image count
	print $fh "$CategoryList[$catindex]->{SUBS}\n";					#sub category count
	print $fh "$CategoryList[$catindex]->{DOWNLOADS}\n";					#image downloads #not filled every time categories are read
	print $fh "$CategoryList[$catindex]->{DESC}\n";
	print $fh "$CategoryList[$catindex]->{IMAGE}\n";	#category icon
	print $fh "$CategoryList[$catindex]->{VISIBLE}\n";					#Visible
	print $fh "$CategoryList[$catindex]->{PROTECTED}\n";				#protected
	print $fh "$CategoryList[$catindex]->{STARTDATE}\n";
	print $fh "$CategoryList[$catindex]->{ENDDATE}\n";
	print $fh "$CategoryList[$catindex]->{USESKIN}\n";
	print $fh "$CategoryList[$catindex]->{SKIN}\n";
	print $fh "$CategoryList[$catindex]->{GROUPS}\n";
	print $fh "$CategoryList[$catindex]->{USERS}\n";
	print $fh "$CategoryList[$catindex]->{LASTMODIFIED}\n";
	CloseFile(\*$fh);
	chmod(0666, "$MediaPath$CategoryList[$catindex]->{PATH}categorydata.cgi");
}

sub FindDirectories {
	my $path = shift;
	unless(chdir($path)) { FatalError("Unable to change working directory to $path.<br>Reason: $!"); }
	opendir(DIR, $path) or FatalError("Unable to open $path for reading!<br>Reason: $!");
	my(@entries) = grep(!/^\.\.?$/, readdir (DIR)); 
	closedir(DIR);
	my @final;
	foreach $dir (@entries) {
		if($dir eq "media" || $dir eq "thumbs") {
			next;
		}
		if(!(-d $dir)) {
			#WriteMessage("$dir was not a directory.");
			next;
		}
		push(@final, $dir);
	}
	return @final;
}

sub FindParentCurrentDir {
	my $index = shift;
	my @Dirs = split(/\//, $CategoryList[$index]->{PATH});
	my $Parent = "";
	my $CurrentDirectory = "";
	for(my $counter = 0; $counter < @Dirs; $counter++) {
		#find parent and current directory
		if($Dirs[$counter + 1] ne "" && $Dirs[$counter] ne "") {
			$Parent = $Parent."/".$Dirs[$counter];
		}  else {
			$CurrentDirectory = $Dirs[$counter];
		}
	}
	$Parent = $Parent."/";
	#WriteMessage("FPC got Parent = $Parent<br>CurrentDirectory = $CurrentDirectory");
	return ($Parent, $CurrentDirectory);
}

sub DeleteCategory {
	my $CatIndex = shift;
	if(!@CategoryList) {
		ReadCategories();
	}
	require $ScriptPath.$slash."media.cgi";	#for move file

	my $CatName = $CategoryList[$CatIndex]->{NAME};
	my($Parent, $CurrentDirectory) = FindParentCurrentDir($CatIndex);
	#before we do any deleting...check to see what to do about sub-cats.
	if($cgi->param("SubsOptionDelete") eq "MoveUp") {
		if($CatIndex + 1 != @CategoryList) {
			if($CategoryList[$CatIndex]->{DEPTH} < $CategoryList[$CatIndex + 1]->{DEPTH}) {
				#there are subs, we need to move them up.
				WriteMessage("Moving Sub Categories up to Parent.");
				#MoveCategory($CatIndex+1, $CatIndex-1);
				MoveCategory($CatIndex+1, GetParentIndex($CatIndex));
			} 
		}
	}	 
	#WriteMessage("Parent = $Parent");
	unless(chdir("$MediaPath$Parent")) { FatalError("Unable to change working directory to $MediaPath$Parent!<br>Reason: $!"); }
	#WriteMessage("Beginning Traverse on $CurrentDirectory");
	TraverseDelete($CurrentDirectory);
	if(-e "categoryorder.cgi") {
		$fh = OpenFile("categoryorder.cgi", "read");
		$order = 0;
		while(<$fh>) {
			$line = $_;
			chomp($line);
			@OrderLine = split(/\|/, $line);
			$OrderFile[$order] = [ @OrderLine ];
			$order++;
		}
		CloseFile(\*$fh);
		$fh = OpenFile("categoryorder.cgi", "write");
		for($counter = 0; $counter < @OrderFile; $counter++) {
			if($OrderFile[$counter][1] eq $CatName) {
				next;
			}
			print $fh $OrderFile[$counter][0]."|".$OrderFile[$counter][1]."\n";
		}
		CloseFile(\*$fh);
	}
	DecCatSubCount(GetParentIndex($CatIndex));
}

sub TraverseDelete {
	my $File = shift;
	my $ParentDir = shift;	#Parent Dir is for removing images from media and thumbs.
	if($File eq "") {
		return;
	}
	#WriteMessage("Traverse: Looking at $File");
	if(-d $File) {
		opendir(DIR, $File) or FatalError("Unable to open directory $File for reading under TraverseDelete!<br>Reason: $!");
		my(@SearchEntries) = grep(!/^\.\.?$/, readdir (DIR)); 
		closedir(DIR);
		unless(chdir($File)) { FatalError("Unable to change to directory $File!<br>Reason: $!"); }
		foreach $entry (@SearchEntries) {
			TraverseDelete($entry, "$ParentDir$File$slash");
		}
		unless(chdir("..")) { FatalError("Unable to change to directory ..<br>Reason: $!"); }
		unless(rmdir("$File")) { FatalError("Unable to remove directory $File<br>Reason: $!"); }
		WriteMessage("Removed Directory: $File");
	} else {
		if($cgi->param("MediaOptionDelete") eq "DeleteMedia") {
			unless(unlink($File)) { FatalError("Unable to unlink $File!<br>Reason: $!"); }
			WriteMessage("Unlinked: $File.");
		} elsif($cgi->param("MediaOptionDelete") eq "MoveToWaiting") {
			if($ParentDir =~ /^(.*?)$slash(media)$slash(.*)$/) {
				my $NewPath = $WaitingPath.$slash."media".$slash.GetFileName($File);
				MoveFile($File, $NewPath);
				WriteMessage("Moved to waiting media: $File");
			} elsif($ParentDir =~ /^(.*?)$slash(thumbs)$slash(.*)$/) {
				my $NewPath = $WaitingPath.$slash."thumbs".$slash.GetFileName($File);
				MoveFile($File, $NewPath);
				WriteMessage("Moved to waiting thumbs: $File");
			} else {
				unless(unlink($File)) { FatalError("Unable to unlink $File!<br>Reason: $!"); }
				WriteMessage("Unlinked: $File.");
			}
		}
	}
}

sub GetFileName {
	$path = shift;
	if($slash eq "\\") {
		my @Dirs = split(/\\\\/, $path);
	} else {
		my @Dirs = split(/\//, $path);
	}
	#my $Parent = "";
	my $filename = "";
	for(my $counter = 0; $counter < @Dirs; $counter++) {
		#find parent and current directory
		if($Dirs[$counter + 1] ne "" && $Dirs[$counter] ne "") {
			#$Parent = $Parent.$slash.$Dirs[$counter];
		}  else {
			$filename = $Dirs[$counter];
		}
	}
	#$Parent = $Parent.$slash;
	#return ($filename, $Parent);
	return $filename;
}

sub GetParentIndex {
	#This function doesn't work all the time...must fix it!
	my $index = shift;
	my $Depth = $CategoryList[$index]->{DEPTH};
	if($Depth == 0) { return -1; }
	for(my $counter = $index; $counter >= 0; $counter--) {
		if($CategoryList[$counter]->{DEPTH} < $Depth) {
			return $counter;
		} elsif($CategoryList[$counter]->{DEPTH} == 0) {
			return -1;
		}
	}
	return -1;
}

sub MoveCategory {
	my $CatIndex = shift;
	my $NewParentIndex = shift;
	if(!@CategoryList) {
		ReadCategories();
	}
	my $NewPath;
	if($NewParentIndex < 0) {
		$NewPath = $slash;
	} else {
		$NewPath = $CategoryList[$NewParentIndex]->{PATH};
	}
	my ($OldParent, $DirName) = FindParentCurrentDir($CatIndex);
	my $CatName = $CategoryList[$CatIndex]->{NAME};
	unless(chdir("$MediaPath$OldParent")) { FatalError("Unable to change directory to $MediaPath$OldParent<br>Reason: $!"); }
	if(-e "categoryorder.cgi") {
		$fh = OpenFile("categoryorder.cgi", "read");
		$order = 0;
		while(<$fh>) {
			$line = $_;
			chomp($line);
			@OrderLine = split(/\|/, $line);
			$OrderFile[$order] = [ @OrderLine ];
			$order++;
		}
		CloseFile(\*$fh);
		$fh = OpenFile("categoryorder.cgi", "write");
		for($counter = 0; $counter < @OrderFile; $counter++) {
			if($OrderFile[$counter][1] eq $CatName) {
				next;
			}
			print $fh $OrderFile[$counter][0]."|".$OrderFile[$counter][1]."\n";
		}
		CloseFile(\*$fh);
		WriteMessage("Removed order entry at source.");
	}
	DecCatSubCount(GetParentIndex($CatIndex));
	require $ScriptPath.$slash."media.cgi";
	if($cgi->param("SubsOptionMove") eq "MoveUp") {
		if($CatIndex + 1 != @CategoryList) {
			if($CategoryList[$CatIndex]->{DEPTH} < $CategoryList[$CatIndex + 1]->{DEPTH}) {
				#there are subs, we need to move them up.
				WriteMessage("Moving Sub Categories up to Parent.");
				MoveCategory($CatIndex+1, GetParentIndex($CatIndex));
			} 
		}
	}	 	
	TraverseMove("$DirName", "$MediaPath$OldParent", "$MediaPath$NewPath");	
	DecCatSubCount(GetParentIndex($CatIndex));
	IncCatSubCount($NewParentIndex);
	WriteMessage("Completed Move of \'$CategoryList[$CatIndex]->{NAME}\' to $NewPath");
	unless(chdir("$MediaPath$NewPath")) { FatalError("Unable to change directory to $MediaPath$NewPath<br>Reason: $!"); }
	if(-e "categoryorder.cgi") {
		$fh = OpenFile("categoryorder.cgi", "append");
		print $fh $NewPath.$DirName."|".$CategoryList[$CatIndex]->{NAME};
		CloseFile(\*$fh);
		WriteMessage("Updated category order file at destination.");
	}
}

sub TraverseMove {
	my $File = shift;
	my $SourcePath = shift;
	my $DestPath = shift;
	if($File eq "") {
		return;
	}
	if(-d "$SourcePath$File") {
		if(-e "$DestPath$File") { FatalError("Unable to move Category<br>Reason: Directory with same name exists in destination."); }
		unless(mkdir("$DestPath$File", 0777)) { FatalError("Unable to make new directory $DestPath$File<br>Reason: $!"); }
		chmod(0777, "$DestPath$File");

		opendir(DIR, "$SourcePath$File") or FatalError("Unable to open directory $File for reading under TraverseMove!<br>Reason: $!");
		my(@SearchEntries) = grep(!/^\.\.?$/, readdir (DIR)); 
		closedir(DIR);
		unless(chdir("$SourcePath$File")) { FatalError("Unable to change to directory $SourcePath$File!<br>Reason: $!"); }
		foreach $entry (@SearchEntries) {
			TraverseMove("$entry", "$SourcePath$File$slash", "$DestPath$File$slash");
		}
		unless(rmdir("$SourcePath$File")) { WriteMessage("Unable to remove directory: $SourcePath$File<br>Reason: $!"); }
		unless(chdir("..")) { FatalError("Unable to change to directory ..<br>Reason: $!"); }
		WriteMessage("Created Directory: $DestPath$File");		
	} else {
		MoveFile("$File", "$DestPath$File");
		#unless(unlink("$SourcePath$File")) { FatalError("Unable to Unlink $File<br>Reason: $!"); }
	}
}

sub MoveDirectory {
	my $source = shift;
	my $dest = shift;
	$sfh = OpenFile("$source", "read");
	$dfh = OpenFile("$dest", "write");
	binmode $dfh;
	binmode $sfh;
	while(read($sfh,$Buffer,1024)) {
		print $dfh $Buffer;
    }
	CloseFile(\*$sfh);
	CloseFile(\*$dfh);
	unlink("$source");
}

sub EditExisitingCategory {
	my $CatIndex = shift;
	if(!@CategoryList) {
		ReadCategories();
	}
	$oldname = $CategoryList[$CatIndex]->{NAME};
	my $RenameDirectory = "false";
	if($oldname ne $cgi->param("categoryname")) {
		#if the name has changed change all dependencies on that name besides categorydata.cgi
		#setup new directory name...
		#modify order file...
		$NewDirectory = $cgi->param("categoryname");
		if($NewDirectory eq /media/i || $NewDirectory eq /thumbs/i) {
			FatalError("Unable to modify category<br>Reason: Category name cannot be called 'media' or 'thumbs'.  Please choose another name.");
		}
		$NewDirectory =~ s/\s/_/g;		#replace whitespace with _
		$NewDirectory =~ s/[\!\?\#\$\@\*\&\^\+\-\~\:\]\[\'\\\/\<\>\|\"\;]//g; #illegal characters, replace with nothing
		$RenameDirectory = "true";
		
		my($Parent, $CurrentDirectory) = FindParentCurrentDir($CatIndex);

		my $file = $MediaPath.$Parent."categoryorder.cgi";
		if(-e $file) {
		$fh = OpenFile($file, "read");
		$order = 0;
		while(<$fh>) {
			$line = $_;
			chomp($line);
			@OrderLine = split(/\|/, $line);
			$OrderFile[$order] = [ @OrderLine ];
			$order++;
		}
		for($counter = 0; $counter < @OrderFile; $counter++) {
			if($OrderFile[$counter][1] eq $oldname) {
				$OrderFile[$counter][0] = "$NewDirectory";
				$OrderFile[$counter][1] = $cgi->param('categoryname');
				last;
			}
		}
		CloseFile(\*$fh);
		$fh = OpenFile($file, "write");
		for($counter = 0; $counter < @OrderFile; $counter++) {
			print $fh $OrderFile[$counter][0]."|".$OrderFile[$counter][1]."\n";
		}
		CloseFile(\*$fh);
		}
	}
	$file = $MediaPath.$CategoryList[$CatIndex]->{PATH}."categorydata.cgi";
	$fh = OpenFile($file, "write");
	print $fh $cgi->param('categoryname')."\n";
	if($CategoryList[$CatIndex]->{COUNT} eq "") {
		$count = 0;
	} else {
		$count = $CategoryList[$CatIndex]->{COUNT};
	}
	if($CategoryList[$CatIndex]->{SUBS} eq "") {
		$subs = 0;
	} else {
		$subs = $CategoryList[$CatIndex]->{SUBS};
	}
	if($CategoryList[$CatIndex]->{IMAGECOUNT} eq "") {
		$imagecount = 0;
	} else {
		$imagecount = $CategoryList[$CatIndex]->{IMAGECOUNT};
	}
	print $fh $count."\n";
	print $fh $subs."\n";
	print $fh $imagecount."\n";
	$newdesc = $cgi->param('description')."\n";
	$newdesc =~ s/\n//g;
	print $fh $newdesc."\n";
	print $fh $cgi->param('image')."\n";
	print $fh $cgi->param('visible')."\n";
	print $fh $cgi->param('protected')."\n";
	if($cgi->param('StartMonth') ne "" && $cgi->param('StartDay') ne "" && $cgi->param('StartYear') ne "") {
		$StartDate = $cgi->param('StartMonth')."/".$cgi->param('StartDay')."/".$cgi->param('StartYear');
	} else {
		$StartDate = "";
	}
	if($cgi->param('EndMonth') ne "" && $cgi->param('EndDay') ne "" && $cgi->param('EndYear') ne "") {
		$EndDate = $cgi->param('EndMonth')."/".$cgi->param('EndDay')."/".$cgi->param('EndYear');
	} else {
		$EndDate = "";
	}
	print $fh $StartDate."\n";
	print $fh $EndDate."\n";
	print $fh $cgi->param('useskin')."\n";
	print $fh $cgi->param('skin')."\n";
	$groups = $cgi->param("groups");
	chomp($groups);
	$groups =~ s/\n/\|/g;
	$groups =~ s/\s//g;
	print $fh $groups."\n";
	$users = $cgi->param("users");
	chomp($users);
	$users =~ s/\n/\|/g;
	$users =~ s/\s//g;
	print $fh $users."\n";
	print $fh $CategoryList[$CatIndex]->{LASTMODIFIED}."\n";
	CloseFile(\*$fh);
	if($RenameDirectory eq "true") {
		unless(chdir("$MediaPath$Parent")) { FatalError("Unable to change working directory to $MediaPath$Parent!<br>Reason: $!"); }
		unless(rename($CurrentDirectory, $NewDirectory)) { WriteMessage("Unable to rename $CurrentDirectory to $NewDirectory!<br>Reason: $!"); }
	}
	$newname = $cgi->param('categoryname');
	WriteMessage("Saved Changes to $oldname => $newname");
	BuildCatData();

}

sub CreateNewCategory {
	if(!@CategoryList) {
		ReadCategories();
	}
	my($ParentIndex) = shift;
	my($NewCatName) = shift;
	my($Parent);
	if($ParentIndex < 0) {
		$Parent = $slash;
		$ParentPath = $MediaPath.$slash;
	} else {
		$Parent = $slash.$CategoryList[$ParentIndex]->{NAME}.$slash;
		$ParentPath = $MediaPath.$CategoryList[$ParentIndex]->{PATH};
	}
	
	if($NewCatName eq "") { FatalError("Category Name is empty."); }
	if($NewCatName eq /media/i || $NewCatName eq /thumbs/i) {
		FatalError("Unable to create category<br>Reason: Category name cannot be called 'media' or 'thumbs'.  Please choose another name.");
	}

	$Directory = $NewCatName;
	$Directory =~ s/\s/_/g;		#replace whitespace with _
	$Directory =~ s/[\!\?\#\$\@\*\&\^\+\-\~\:\]\[\'\\\/\<\>\|\"\;]//g; #illegal characters, replace with nothing

	WriteMessage("Parent is : $Parent\n");
	WriteMessage("Cat is : $NewCatName\n");
	#WriteMessage("Parent Path is $ParentPath");
	WriteMessage("Fullpath will be : $ParentPath$Directory\n");
	unless(chdir($ParentPath)) { FatalError("Unable to change working directory to $ParentPath!<br>Reason: $!"); }
	if(-e $Directory ) { FatalError("Directory already exists, unable to create new cateogry!"); }
	#checks are good, lets get dirty...
	unless(mkdir($Directory, 0777)) { FatalError("Unable to create directory $Directory!<br>Reason: $!"); }
	chmod(0777, $Directory);
	#add category to order file
	if(-e "categoryorder.cgi") {
		$fh = OpenFile("categoryorder.cgi", "append");
		print $fh $Directory."|".$NewCatName."\n";
		CloseFile(\*$fh);
		chmod(0666, "categoryorder.cgi");
	}
	#unless(chdir("$ParentPath/$Directory")) { FatalError("Unable to change working directory to $ParentPath$Directory!<br>Reason: $!"); }
	unless(chdir("$Directory")) { FatalError("Unable to change working directory to $Directory under $ParentPath!<br>Reason: $!"); }
	$fh = OpenFile("categorydata.cgi", "write");
	print $fh "$NewCatName\n";
	print $fh "0\n";					#image count
	print $fh "0\n";					#sub category count
	print $fh "0\n";					#image downloads #not filled every time categories are read
	print $fh $cgi->param("description")."\n";
	print $fh $cgi->param("image")."\n";	#category icon
	print $fh $cgi->param("visible")."\n";					#Visible
	print $fh $cgi->param("protected")."\n";				#protected
	if($cgi->param('StartMonth') ne "" && $cgi->param('StartDay') ne "" && $cgi->param('StartYear') ne "") {
		$StartDate = $cgi->param('StartMonth')."/".$cgi->param('StartDay')."/".$cgi->param('StartYear');
	} else {
		$StartDate = "";
	}
	if($cgi->param('EndMonth') ne "" && $cgi->param('EndDay') ne "" && $cgi->param('EndYear') ne "") {
		$EndDate = $cgi->param('EndMonth')."/".$cgi->param('EndDay')."/".$cgi->param('EndYear');
	} else {
		$EndDate = "";
	}
	print $fh $StartDate."\n";
	print $fh $EndDate."\n";
	print $fh $cgi->param('useskin')."\n";
	print $fh $cgi->param('skin')."\n";
	$groups = $cgi->param("groups");
	chomp($groups);
	$groups =~ s/\n/\|/g;
	$groups =~ s/\s//g;
	print $fh $groups."\n";
	$users = $cgi->param("users");
	chomp($users);
	$users =~ s/\n/\|/g;
	$users =~ s/\s//g;
	print $fh $users."\n";
	print $fh "Last Modified\n";
	CloseFile(\*$fh);
	chmod(0666, "categorydata.cgi");
	$fh = OpenFile("imagedata.cgi", "write");
	CloseFile(\*$fh);
	chmod(0666, "imagedata.cgi");
	unless(mkdir("media", 0777)) { FatalError("Unable to create directory media under $NewCatName!<br>Reason: $!"); }
	chmod(0777, "media");
	unless(mkdir("thumbs", 0777)) { FatalError("Unable to create directory thumbs under $NewCatName!<br>Reason: $!"); }
	chmod(0777, "thumbs");
	IncCatSubCount($ParentIndex);
	WriteMessage("Category '$NewCatName' under '$Parent' has been created as: $Directory.");
}

sub ReadCategories {
	if(not defined $MediaPath) {
		FatalError("Path to media directory is undefined!");
	}
	if(!(-e $MediaPath.$slash."allcategories.cgi")) {
		@CategoryList = ();
		return;
	}
	$fh = OpenFile($MediaPath.$slash."allcategories.cgi", "read");
	if(defined $fh) {
		@CategoryList = ();
		my($counter) = 0;
		while(<$fh>) {
			my($line) = $_;
			if($line =~ /^\[ArcadiaDB(.*?)\](.*)$/) {
				next;
			}
			chomp($line);
			@list = split('\|',$line);
			if($list[0] ne "" && $list[1] ne "") {
				my($record) = ();
				$record = {
					PATH		=> $list[0],
					DEPTH		=> $list[1],
					NAME		=> $list[2],
					COUNT		=> $list[3],
					SUBS		=> $list[4],
					DOWNLOADS	=> $list[5],
					DESC		=> $list[6],
					IMAGE		=> $list[7],
					VISIBLE		=> $list[8],
					PROTECTED	=> $list[9],
					STARTDATE	=> $list[10],
					ENDDATE		=> $list[11],
					USESKIN		=> $list[12],
					SKIN		=> $list[13],
					GROUPS		=> $list[14],
					USERS		=> $list[15],
					LASTMODIFIED=> $list[16],
					INDEX		=> $counter
				};
				$CategoryList[$counter] = $record;
				$counter++;
			}
		}
		CloseFile(\*$fh);
	}		
	#PrintHeader();
	#for($counter = 0; $counter < @CategoryList; $counter++) {
	#	print "<p><b>$counter:<br>";
	#	print "PATH: $CategoryList[$counter]->{PATH}<br>";
	#	print "NAME: $CategoryList[$counter]->{NAME}<br>";
	#	print "COUNT: $CategoryList[$counter]->{COUNT}<br>";
	#	print "SUBS: $CategoryList[$counter]->{SUBS}<br>";
	#	print "DESC: $CategoryList[$counter]->{DESC}<br>";
	#	print "IMAGE: $CategoryList[$counter]->{IMAGE}<br>";
	#	print "VISIBLE: $CategoryList[$counter]->{VISIBLE}<br>";
	#	print "PROTECTED: $CategoryList[$counter]->{PROTECTED}<br>";
	#	print "GROUP: $CategoryList[$counter]->{GROUP}<br>";
	#	print "STARTDATE: $CategoryList[$counter]->{STARTDATE}<br>";
	#	print "ENDDATE: $CategoryList[$counter]->{ENDDATE}<br>";
	#}
}

sub IncCatImageCount {
	my $cat = shift;
	if(!@CategoryList) { ReadCategories(); }
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "read");
	@CatData = <$fh>;
	CloseFile(\*$fh);
	chomp($CatData[1]);
	my $count = int($CatData[1]);
	$count++;
	$CatData[1] = $count."\n";
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "write");
	foreach $data (@CatData) {
		if($data eq "") {
			print $fh "\n";
		} else {
			print $fh $data;
		}
	}
	CloseFile(\*$fh);
	BuildCatData();
}

sub DecCatImageCount {
	my $cat = shift;
	if(!@CategoryList) { ReadCategories(); }
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "read");
	@CatData = <$fh>;
	CloseFile(\*$fh);
	chomp($CatData[1]);
	my $count = int($CatData[1]);
	$count--;
	$CatData[1] = $count."\n";
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "write");
	foreach $data (@CatData) {
		if($data eq "") {
			print $fh "\n";
		} else {
			print $fh $data;
		}
	}
	CloseFile(\*$fh);
	BuildCatData();
}

sub IncCatSubCount {
	my $cat = shift;
	if($cat < 0) { return; }
	if(!@CategoryList) { ReadCategories(); }
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "read");
	@CatData = <$fh>;
	CloseFile(\*$fh);
	chomp($CatData[2]);
	my $count = int($CatData[2]);
	$count++;
	$CatData[2] = $count."\n";
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "write");
	foreach $data (@CatData) {
		if($data eq "") {
			print $fh "\n";
		} else {
			print $fh $data;
		}
	}
	CloseFile(\*$fh);
	BuildCatData();
}

sub DecCatSubCount {
	my $cat = shift;
	if(!(-e "$MediaPath.$CategoryList[$cat]->{PATH}.categorydata.cgi")) { return; }
	if(!@CategoryList) { ReadCategories(); }
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "read");
	@CatData = <$fh>;
	CloseFile(\*$fh);
	chomp($CatData[2]);
	my $count = int($CatData[2]);
	$count--;
	$CatData[2] = $count."\n";
	$fh = OpenFile($MediaPath.$CategoryList[$cat]->{PATH}."categorydata.cgi", "write");
	foreach $data (@CatData) {
		if($data eq "") {
			print $fh "\n";
		} else {
			print $fh $data;
		}
	}
	CloseFile(\*$fh);
	BuildCatData();
}

sub ReCalcImagesPerCat {
	#needed just in case category image count fucks up.  
	#a 'just in case' function
	for($counter = 0; $counter < @CategoryList; $counter++) {
		$CategoryList[$counter][1] = 0;
	}
	for($counter = 0; $counter < @ImageList; $counter++) {
		for($num = 0; $num < @CategoryList; $num++) {
			if($CategoryList[$num][0] eq $ImageList[$counter][$CATEGORY]) {
				$CategoryList[$num][1]++;
			}
		}
	}
	$fh = OpenFile($categorydata, "write");
	if(defined $fh) {
		for($num = 0; $num < @CategoryList; $num++) {
			print $fh $CategoryList[$num][0]."|".$CategoryList[$num][1]."\n";
		}
		CloseFile(\*$fh);
	}
	$message = "Recounted images in all categories.";
	Write_Message($message);
}


sub CalcDownloadsPerCat {
	#must call after Read_Cats, Read_Images, Read_Image_Data
	#Don't call to much, does too much work for nothing.
	@Downloads = ();
	my($counter);
	#print "Looping now<br>";
	for($counter = 0; $counter < @CategoryList; $counter++) {
		$Downloads[$counter] = 0;
		for($num = 0; $num < @ImageList; $num++) {
			#print "$CategoryList[$counter][0] versus $ImageList[$num][$CATEGORY]<br>";
			if($CategoryList[$counter][0] eq $ImageList[$num][$CATEGORY]) {
				$Downloads[$counter] = $Downloads[$counter] + $ImageList[$num][$DOWNLOADS];
			}
		}
	}
	#for($counter = 0; $counter < @Downloads; $counter++) {
	#	print "Category $counter downloads : $Downloads[$counter]<br>";
	#}
}		

sub BuildCatInline {
	my($index) = shift;
	if(!@CategoryList) {
		ReadCategories();
	}
	my($parent) = -1;
	@CatInline = ();
	my($counter) = 0;
	#find parent...
	for($counter = 0; $counter <= $index; $counter++) {
		if($CategoryList[$counter]->{DEPTH} == 0) {
			$parent = $counter;
		}
	}
	#print "<b>Parent index is $parent<br>";
	my($num) = 0;
	#add the rest above the category
	my($CurrentTier) = $CategoryList[$index]->{DEPTH};
	for($counter = $index; $counter >= $parent; $counter--) {
		if($CategoryList[$counter]->{DEPTH} == $CurrentTier) {
			if($CategoryList[$counter]->{VISIBLE} eq "true" && 
				GoodStartDate($CategoryList[$counter]->{STARTDATE}) && 
				GoodEndDate($CategoryList[$counter]->{ENDDATE})) {

				$CatInline[$num] = $CategoryList[$counter];
				$num++;
				$CurrentTier--;
			}
		}
	}
	@CatInline = reverse @CatInline;
	#Piece of Pie.

	#PrintHeader();
	#for($counter = 0; $counter < @CatInline; $counter++) {
	#	print "<b>CatInline[$counter] = $CatInline[$counter]->{NAME} at $CatInline[$counter]->{PATH}<br>";
	#}
}

sub BuildCatTree {
	my($index) = shift;
	if(!@CategoryList) {
		ReadCategories();
	}
	my($parent) = -1;
	@CatTree = ();
	my($counter) = 0;
	#First things first, find the parent of the current category
	for($counter = 0; $counter <= $index; $counter++) {
		if($CategoryList[$counter]->{DEPTH} == 0) {
			$parent = $counter;
		}
	}
	#print "<b>Parent index is $parent<br>";
	#now go forward and see if there are any sub cats directly below and add them to the new list
	my(@SubCats) = ();
	my($num) = 0;
	for($counter = $index + 1; $counter < @CategoryList; $counter++) {
		if ($CategoryList[$counter]->{DEPTH} == ($CategoryList[$index]->{DEPTH}) + 1) {
			if($CategoryList[$counter]->{VISIBLE} eq "true" && 
				GoodStartDate($CategoryList[$counter]->{STARTDATE}) && 
				GoodEndDate($CategoryList[$counter]->{ENDDATE})) {

				$SubCats[$num] = $CategoryList[$counter];
				$num++;
			}
		}
		if($CategoryList[$counter]->{DEPTH} <= $CategoryList[$index]->{DEPTH}) {
			last;
		}
	}
	#now go through and add any categories that are on the same level.
	#actually don't do that...
	#for($counter = $index + 1; $counter < @CategoryList; $counter++) {
	#	if($CategoryList[$counter]->{DEPTH} == $CategoryList[$index]->{DEPTH}) {
	#		$SubCats[$num] = $CategoryList[$counter];
	#		$num++;
	#	}
	#}
	@CatTree = reverse @SubCats;
	#now add any categories above the current
	my($CurrentTier) = $CategoryList[$index]->{DEPTH};
	for($counter = $index; $counter >= $parent; $counter--) {
		if($CategoryList[$counter]->{DEPTH} == $CurrentTier) {
			if($CategoryList[$counter]->{VISIBLE} eq "true" && 
				GoodStartDate($CategoryList[$counter]->{STARTDATE}) && 
				GoodEndDate($CategoryList[$counter]->{ENDDATE})) {

				$CatTree[$num] = $CategoryList[$counter];
				$num++;
				$CurrentTier--;
			}
		}
	}
	@CatTree = reverse @CatTree;	   
	
	#and I'm spent...

	#PrintHeader();
	#for($counter = 0; $counter < @CatTree; $counter++) {
	#	print "<b>CatTree[$counter] = $CatTree[$counter]->{NAME} at $CatTree[$counter]->{PATH}<br>";
	#}
}	

sub FindSubCategories {
	#Maybe use for build ?? who knows???  Not used for navigation right now!!
	my($index) = shift;
	if($index eq "") { $index = $CategoryIndex; }
	if(!@CategoryList) {
		ReadCategories();
	}
	my($subdepth) = $CategoryList[$index]->{DEPTH};
	$subdepth++;
	my($num) = 0;
	@SubCats = ();
	my($counter) = $index + 1;
	for($counter; $counter < @CategoryList; $counter++) {
		if($CategoryList[$counter]->{DEPTH} > $subdepth) {
			next;
		} elsif($CategoryList[$counter]->{DEPTH} < $subdepth) {
			last;
		} elsif($CategoryList[$counter]->{VISIBLE} eq "true" && 
				GoodStartDate($CategoryList[$counter]->{STARTDATE}) && 
				GoodEndDate($CategoryList[$counter]->{ENDDATE})) {

			$SubCats[$num] = $CategoryList[$counter];
			$num++;
		}
	}		
	#for(my($counter) = 0; $counter < @SubCats; $counter++) {
	#	WriteMessage("$SubCats[$counter]->{NAME}");
	#}
	my($count) = @SubCats;
	return $count;
}

1;