##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################


# display.cgi
#	This purpose of this file is to eliminate the template vs.
#	standard html decisions.  This file is included no matter
#	what at invocation of the script.  Then based on whether
#	or not the admin wants to use templates or basic html and if
#	the correct template exists, the functions in this file 
#	will load the correct html or template modules and print 
#	the correct html.
#
#	Some may wonder why I've included the admin display calls under
#	here as well - well, I may or may not in the future allow the 
#	config to be skinned as well, plus, it keeps up with the logic of
#	the gallery display calls.

$HeaderPrinted = "false";

sub PrintHeader {
	if($HeaderPrinted eq "false") {
		print "Content-type: text/html\n\n";
		print "<html>";
		$HeaderPrinted = "true";
	}
}	

sub WriteMessage {
	PrintHeader();
	$message = shift;
	#lets perform some cool little format tricks, allows for faster typing later on...
	$message =~ s/\\n/<br>/g;
	$message =~ s/\\t/&nbsp;&nbsp;&nbsp;&nbsp;/g;
	#$message =~ s/\\t/<blockquote>/g;
	#$message =~ s/<blockquote>/<\/blockquote>$/g;
	print qq~
	<p><b><font size="$FontSize" face="$FontFace">$message</font></b></p>
	~;
}

sub WriteCopyright {
	print qq~
		<center>
		<p class="Copyright"><font face="$FontFace" color="$CopyrightFontColor" size="$FontSize" class="Copyright"><small>Powered By <a class="Copyright" href="http://www.imagearcadia.com/">Image Arcadia</a>
		Copyright 2000-2001 <a class="Copyright" href="http://www.ikingnet.com/" target="new">iKing Networks</a></small></font></p></center>
	~;
}

sub FatalError {
	#PrintHeader();
	$message = shift @_;
	my($html) = qq~
	<p><b><font size="$FontSize" face="$FontFace" color="$FontColor">$message</font></b></p>
	~;
	if($UseSkin && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print BlankTemplate($html);
	} else {
		require $ScriptPath.$slash."html.cgi";
		BlankPageHtml($html);
	}
	exit;
}

sub Success {
	$message = shift @_;
	my($html) = qq~
	<p><b><font size="$FontSize" face="$FontFace" color="$FontColor">$message</font></b></p>
	~;
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print BlankTemplate($html);
	} else {
		require $ScriptPath.$slash."html.cgi";
		BlankPageHtml($html);
	} 
	exit;
}

sub ShowUpload() {
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print UploadTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		UploadHtml();
	}
	exit;
}

sub ShowLogin {
	$message = shift;
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print LoginTemplate($message);
	} else {
		require $ScriptPath.$slash."html.cgi";
		LoginHtml($message);
	}
	exit;
}

sub ShowSearchForm {
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print SearchTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		SearchHtml();
	}
	exit;
}

sub ShowSortOptions {
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print SortTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		SortHtml();
	}	
	exit;
}

sub ShowAdminLogin {
	$message = shift;
	require $ScriptPath.$slash."adminhtml.cgi";
	AdminLoginHtml($message);
}

sub ShowConfigMain {
	require $ScriptPath.$slash."adminhtml.cgi";
	ConfigMainHtml();
}

sub ShowPlugins {
	require $ScriptPath.$slash."adminhtml.cgi";
	ListPluginsHtml();
}

sub ShowEditPaths {
	require $ScriptPath.$slash."adminhtml.cgi";
	EditPathsHtml();
}

sub ShowEditAllCategories {
	require $ScriptPath.$slash."adminhtml.cgi";
	EditAllCategoriesHtml();
}

sub ShowEditCategory {
	my $CatIndex = shift;
	require $ScriptPath.$slash."adminhtml.cgi";
	EditCategoryHtml($CatIndex);
}

sub ShowConfirmDeleteCategory {
	require $ScriptPath.$slash."adminhtml.cgi";
	DeleteCategoryConfirmationHtml($cgi->param("category"));
}

sub ShowConfirmMoveCategory {
	require $ScriptPath.$slash."adminhtml.cgi";
	MoveCategoryConfirmation($cgi->param("category"));
}

sub ShowCreateCategory {
	require $ScriptPath.$slash."adminhtml.cgi";
	CreateCategoryHtml();
}

sub ShowAddNewImages {
	require $ScriptPath.$slash."adminhtml.cgi";
	AddNewImagesHtml();
}

sub ShowApproveWaitingHtml {
	require $ScriptPath.$slash."adminhtml.cgi";
	ApproveWaitingImagesHtml();
}

sub ShowEditExistingImages {
	require $ScriptPath.$slash."adminhtml.cgi";
	EditExistingImagesHtml();
}

sub ShowSearchExistingImages {
	require $ScriptPath.$slash."adminhtml.cgi";
	SearchExistingImagesHtml();
}

sub ShowFileTypes {
	require $ScriptPath.$slash."adminhtml.cgi";
	FileTypesHtml();
}

sub ShowStyleSettings {
	require $ScriptPath.$slash."adminhtml.cgi";
	StyleSettingsHtml();
}

sub ShowDisplayOptions {
	require $ScriptPath.$slash."adminhtml.cgi";
	DisplayOptionsHtml();
}

sub ShowSearchUsers {
	require $ScriptPath.$slash."adminhtml.cgi";
	SearchUsersHtml();
}

sub ShowSearchUsersResults {
	require $ScriptPath.$slash."adminhtml.cgi";
	if($cgi->param("displayall") eq "on") {
		GetFullUserList();
	} elsif($cgi->param("searchuser") ne "") {
		FindUserByUsername($cgi->param("searchuser"));
	} else {
		FindUserByEmail($cgi->param("searchemail"));
	}
	SearchUserResultsHtml();
}

sub ShowEditUser {
	require $ScriptPath.$slash."adminhtml.cgi";
	EditUserHtml();
}

sub ShowCreateUser {
	require $ScriptPath.$slash."adminhtml.cgi";
	CreateUserHtml();
}

sub ShowConfirmDeleteUser {
	require $ScriptPath.$slash."adminhtml.cgi";
	ConfirmDeleteUserHtml();
}

sub ShowViewGroups {
	require $ScriptPath.$slash."adminhtml.cgi";
	ViewGroupsHtml();
}	

sub ShowEditGroup {
	require $ScriptPath.$slash."adminhtml.cgi";
	EditGroupHtml();
}

sub ShowCreateGroup {
	require $ScriptPath.$slash."adminhtml.cgi";
	CreateGroupHtml();
}

sub ShowConfirmDeleteGroup {
	require $ScriptPath.$slash."adminhtml.cgi";
	ConfirmDeleteGroupHtml();
}

sub ShowCategoryListing {
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."categorylisting.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print CategoryTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		CategoryHtml();
	}
	exit;
}

sub ShowGallery {
	if(($UseSkin eq "true" || $CategoryList[$CategoryIndex]->{USESKIN} eq "true") &&
		(-e $SkinPath.$slash.$CategoryList[$CategoryIndex]->{SKIN}.$slash."gallery.html" || -e $SkinPath.$slash.$DefaultSkin.$slash."gallery.html")) {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print GalleryTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		GalleryHtml();
	}
	exit;
}

sub ShowMedia {
	if(($UseSkin eq "true" || $CategoryList[$CategoryIndex]->{USESKIN} eq "true") &&
		(-e $SkinPath.$slash.$CategoryList[$CategoryIndex]->{SKIN}.$slash."media.html" || -e $SkinPath.$slash.$DefaultSkin.$slash."media.html")) {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print MediaTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		MediaHtml();
	}
	exit;	
}

sub ShowRegister {
	if($UseSkin eq "true" && -e $SkinPath.$slash.$DefaultSkin.$slash."blank.html") {
		require $ScriptPath.$slash."template.cgi";
		PrintHeader();
		print RegisterTemplate();
	} else {
		require $ScriptPath.$slash."html.cgi";
		RegisterHtml();
	}
	exit;
}
1;