##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# media.cgi

#Indexes into the database array
$FILENAME = 0;
$THUMBNAME = 1;
$TYPE = 2;
$DATE = 3;
$COPYRIGHT = 4;
$AUTHOR = 5;
$DOWNLOADS = 6;
$VOTES = 7;
$RATING = 8;
$DESCRIPTION = 9;
$USER = 10;		#who uploaded it
$IP = 11;		#ip of who uploaded it
$PATH = 12;
$CATINDEX = 13;
$NEWCATINDEX = 14;

sub ReadMedia {
	my($index) = shift;
	my($searchterm) = shift;
	my($searchindex) = shift;

	if($index eq "") {
		WriteMessage("No Category specified");
		return;
	}
	if(!@CategoryList) {
		require $ScriptPath.$slash."categories.cgi";
		ReadCategories();
	}
	@MediaList = ();
	my $mediacount = 0;
	#This loop is in case we need all the images read in.  Pass in index < 0 to
	#Read them all or specify a category index to read only 1
	my $goahead;
	for(my $counter = 0; $counter < @CategoryList; $counter++) {
		if($index < 0) {
			if($CategoryList[$CategoryIndex]->{PROTECTED} eq "true") {
				if(($CategoryList[$CategoryIndex]->{GROUPS} =~ /$UserProfile[15]/ && $UserProfile[15] ne "") ||
					$CategoryList[$CategoryIndex]->{USERS} =~ /$Username/) {
					$goahead = "true";
				} else {
					next;
				}
			}
			$File = $MediaPath.$CategoryList[$counter]->{PATH}."imagedata.cgi";
			$path = $CategoryList[$counter]->{PATH};
		} else {
			$File = $MediaPath.$CategoryList[$index]->{PATH}."imagedata.cgi";
			$path = $CategoryList[$index]->{PATH}
		}	
		if(!(-e $File)) {
			#WriteMessage("Unable to read Media Database, $File does not exist.");
			#return;
			if($index >= 0) {
				last;
			} else {
				next;
			}
		}
		#WriteMessage("Reading $File");
		$fh = OpenFile($File, "read");
		if(defined $fh) {
			my(@MediaData) = ();
			while(<$fh>) {
				$line = $_;
				if($line =~ /^\[ArcadiaDB(.*?)\](.*)$/) {
					next;
				}
				chomp($line);
				@list = split('\|',$line);
				if($searchterm ne "") {
					#WriteMessage("Checking $list[$searchindex] with '$searchterm'");
					if($searchindex >= 0) {
						$value = $list[$searchindex];
					} else {
						$value = $line;
					}
					if($value =~ m/(.*?)$searchterm(.*?)/gi) {
						push(@MediaData, $list[$FILENAME]);
						push(@MediaData, $list[$THUMBNAME]);
						push(@MediaData, $list[$TYPE]);
						push(@MediaData, $list[$DATE]);
						push(@MediaData, $list[$COPYRIGHT]);
						push(@MediaData, $list[$AUTHOR]);
						push(@MediaData, $list[$DOWNLOADS]);
						push(@MediaData, $list[$VOTES]);
						push(@MediaData, $list[$RATING]);
						push(@MediaData, $list[$DESCRIPTION]);
						push(@MediaData, $list[$USER]);
						push(@MediaData, $list[$IP]);
						push(@MediaData, $path);
						if($index < 0) {
							push(@MediaData, $counter);
						} else {
							push(@MediaData, $index);
						}
						$MediaList[$mediacount] = [ @MediaData ];
						@MediaData=(); 
						$mediacount++;
					}
				} elsif($list[0] ne "" && $list[1] ne "") {
					push(@MediaData, $list[$FILENAME]);
					push(@MediaData, $list[$THUMBNAME]);
					push(@MediaData, $list[$TYPE]);
					push(@MediaData, $list[$DATE]);
					push(@MediaData, $list[$COPYRIGHT]);
					push(@MediaData, $list[$AUTHOR]);
					push(@MediaData, $list[$DOWNLOADS]);
					push(@MediaData, $list[$VOTES]);
					push(@MediaData, $list[$RATING]);
					push(@MediaData, $list[$DESCRIPTION]);
					push(@MediaData, $list[$USER]);
					push(@MediaData, $list[$IP]);
					push(@MediaData, $path);
					if($index < 0) {
						push(@MediaData, $counter);
					} else {
						push(@MediaData, $index);
					}
					$MediaList[$mediacount] = [ @MediaData ];
					@MediaData=(); 
					$mediacount++;	
				}
			}
			CloseFile(\*$fh);
		}
		if($index >= 0) {
			last;
		}
	}
	if($SortBy eq "filename") {
		@MediaList = sort ByFilename @MediaList;
	} elsif($SortBy eq "thumbnail") {
		@MediaList = sort ByThumb @MediaList;
	} elsif($SortBy eq "type") {
		@MediaList = sort ByType @MediaList;
	} elsif($SortBy eq "date") {
		@MediaList = sort ByDate @MediaList;
	} elsif($SortBy eq "copyright") {
		@MediaList = sort ByCopyright @MediaList;
	} elsif($SortBy eq "author") {
		@MediaList = sort ByAuthor @MediaList;
	} elsif($SortBy eq "downloads") {
		@MediaList = sort ByDownloads @MediaList;
	} elsif($SortBy eq "votes") {
		@MediaList = sort ByVotes @MediaList;
	} elsif($SortBy eq "rating") {
		@MediaList = sort ByRating @MediaList;
	} elsif($SortBy eq "description") {
		@MediaList = sort ByDescription @MediaList;
	} elsif($SortBy eq "user") {
		@MediaList = sort ByUser @MediaList;
	}
	#WriteMessage("MediaList looks like:");
	#for($counter = 0; $counter < @MediaList; $counter++) {
	#	WriteMessage("$counter: $MediaList[$counter][0] $MediaList[$counter][1] $MediaList[$counter][2] $MediaList[$counter][3] $MediaList[$counter][4] $MediaList[$counter][5] $MediaList[$counter][6]");
	#}
}

sub ReadMediaShow {
	my $catindex = shift;
	my $filename = shift;
	if(!@CategoryList) {
		require $ScriptPath.$slash."categories.cgi";
		ReadCategories();
	}
	$fh = OpenFile("$MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi", "read");
	@ShowData=();
	while (<$fh>) {
		$line = $_;
		chomp($line);
		@list = split('\|',$line);
		if($list[0] ne "" && $list[1] ne "" && $list[2] ne "" && $list[3] ne "") {
			if($list[$FILENAME] eq $filename) {
				push(@ShowData, $list[$FILENAME]);
				push(@ShowData, $list[$THUMBNAME]);
				push(@ShowData, $list[$TYPE]);
				push(@ShowData, $list[$DATE]);
				push(@ShowData, $list[$COPYRIGHT]);
				push(@ShowData, $list[$AUTHOR]);
				push(@ShowData, $list[$DOWNLOADS]);
				push(@ShowData, $list[$VOTES]);
				push(@ShowData, $list[$RATING]);
				push(@ShowData, $list[$DESCRIPTION]);
				push(@ShowData, $list[$USER]);
				push(@ShowData, $list[$IP]);
				last;
			}
		}
	}
	CloseFile(\*$fh);
}

###############################################################
# WriteMedia
#	Writes the database back out to file, used with 
#	IncrementDownload();
###############################################################

sub WriteMedia {
	my $catindex = shift;
	$fh = OpenFile("$MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi", "write");
	#WriteMessage("Opening $MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi for WriteMedia.");
	for(my $counter = 0; $counter < @MediaList; $counter++) {
		#WriteMessage("Writing: ".$MediaList[$counter][0]."|".$MediaList[$counter][1]."|".$MediaList[$counter][2]."|".$MediaList[$counter][3]."|".$MediaList[$counter][4]."|".$MediaList[$counter][5]."|".$MediaList[$counter][6]."|".$MediaList[$counter][7]."|".$MediaList[$counter][8]."|".
		#		$MediaList[$counter][9]."|".$MediaList[$counter][10]."|".$MediaList[$counter][11]."\n");
		if($MediaList[$counter][$FILENAME] ne "") {
			print $fh $MediaList[$counter][0]."|".$MediaList[$counter][1]."|".$MediaList[$counter][2]."|".$MediaList[$counter][3]."|".
				$MediaList[$counter][4]."|".$MediaList[$counter][5]."|".$MediaList[$counter][6]."|".$MediaList[$counter][7]."|".
				$MediaList[$counter][8]."|".$MediaList[$counter][9]."|".$MediaList[$counter][10]."|".$MediaList[$counter][11]."\n";
		}
	}
	CloseFile(\*$fh);
}

sub SaveMediaEntry {
	my $filename = shift;
	my $catindex = shift;
	my @NewData = @_;
	$fh = OpenFile("$MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi", "read");
	@Data = <$fh>;
	for(my $counter = 0; $counter < @Data; $counter++) {
		@list = split(/\|/, $Data[$counter]);
		if($list[$FILENAME] eq $filename) {
			#my $temp = join('|', @NewData);
			$temp = $NewData[0]."|".$NewData[1]."|".$NewData[2]."|".$NewData[3]."|".$NewData[4]."|".$NewData[5]."|".
					$NewData[6]."|".$NewData[7]."|".$NewData[8]."|".$NewData[9]."|".$NewData[10]."|".$NewData[11]."|".
					$NewData[12]."\n";
			#foreach $data (@NewData) { $temp = $temp."|".$data; }
			WriteMessage("Updating $list[$FILENAME] with $temp");
			$Data[$counter] = $temp;
			#$Data[$counter] = join("|", @NewData);
			last;
		}
	}
	CloseFile(\*$fh);
	$fh = OpenFile("$MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi", "write");
	for(my $counter = 0; $counter < @Data; $counter++) {
		WriteMessage("Writing: ".$Data[$counter]);
		chomp($Data[$counter]);
		print $fh $Data[$counter]."\n";
	}
	CloseFile(\*$fh);
}

###############################################################
# FindNewMedia()
#	Basic Batch add function.  Specify directory index or -1 for
#	all directories and it will search for media not in the 
#	database but in the category already.
###############################################################

sub FindNewMedia {
	$catindex = shift;
	#if -1 do all categories
	GetDateTime();
	if(!@CategoryList) {
		require $ScriptPath.$slash."categories.cgi";
		ReadCategories();
	}
	$imagecount = 0;
	if($catindex < 0) {
		WriteMessage("Searching all categories for new Media.");
		for(my $counter = 0; $counter < @CategoryList; $counter++) {
			WriteMessage("Checking: $CategoryList[$counter]->{NAME}");
			opendir(DIR, "$MediaPath$CategoryList[$counter]->{PATH}media");
			my(@files) = grep(!/^\.\.?$/, readdir (DIR)); 
			closedir(DIR);
			ReadMedia($counter);
			foreach $entry (@files) {
				my($found) = "false";
				for(my $j = 0; $j < @MediaList; $j++) {
					if($entry eq $MediaList[$j][0]) {
						$found = "true";
						last;
					}
				}
				if($found eq "false") {
					#Add the file					
					my $ext = GetFileExt($entry);
					my @filename = split(/\./, $entry);
					my $thumb;
					if(($ext !~ /jpg/i) || ($ext !~ /gif/i) || ($ext !~ /png/i)) {
						if($DefaultThumbType eq "") { $DefaultThumbType = "jpg"; }
						$thumb = "$ThumbPrefix$filename[0]$ThumbSuffix.$DefaultThumbType";
					} else {
						$thumb = "$ThumbPrefix$filename[0]$ThumbSuffix.$ext";
					}
					my(@TempData) = ();
					push(@TempData, $entry);
					push(@TempData, $thumb);
					push(@TempData, AssignType($entry));
					push(@TempData,	$DateTime);
					push(@TempData, "NODATA");
					push(@TempData, "NODATA");
					push(@TempData, "0");
					push(@TempData, "0");
					push(@TempData, "0");
					push(@TempData, "NODATA");
					push(@TempData, "$Username");
					push(@TempData, "$ENV{'REMOTE_ADDR'}");
					WriteMessage("Found a file not in $CategoryList[$counter]->{NAME} Database: $entry");
					AddMedia($counter, @TempData);
					$imagecount++;

				}
			}
		}
	} else {
		WriteMessage("Searching $CategoryList[$catindex]->{NAME} for new Media.");
		opendir(DIR, "$MediaPath$CategoryList[$catindex]->{PATH}media");
		my(@files) = grep(!/^\.\.?$/, readdir (DIR)); 
		closedir(DIR);
		ReadMedia($catindex);
		foreach $entry (@files) {
			my($found) = "false";
			for(my $j = 0; $j < @MediaList; $j++) {
				if($entry eq $MediaList[$j][0]) {
					$found = "true";
					last;
				}
			}
			if($found eq "false") {
				#Add the file					
				my $ext = GetFileExt($entry);
				my $filename;
				$filename = split(/\./, $entry);
				my $thumb;
				if($ext !~ /jpg/i || $ext !~ /gif/i || $ext !~ /png/i) {
					$thumb = "$ThumbPrefix$filename$ThumbSuffix.$DefaultThumbType";
				} else {
					$thumb = "$ThumbPrefix$filename$ThumbSuffix.$ext";
				}
				my(@TempData) = ();
				push(@TempData, $entry);
				push(@TempData, $thumb);
				push(@TempData, AssignType($entry));
				push(@TempData,	$DateTime);
				push(@TempData, "NODATA");
				push(@TempData, "NODATA");
				push(@TempData, "0");
				push(@TempData, "0");
				push(@TempData, "0");
				push(@TempData, "NODATA");
				push(@TempData, "$Username");
				push(@TempData, "$ENV{'REMOTE_ADDR'}");
				WriteMessage("Found a file not in $CategoryList[$catindex]->{NAME} Database: $entry");
				AddMedia($catindex, @TempData);
				$imagecount++;
			}
		}
	}
	WriteMessage("Found a total of $imagecount new images.");
}

###############################################################
# AddMedia
#	Adds image data to the proper image database, category or
#	waiting.  DOES NOT MOVE FILE FOR YOU
###############################################################

sub AddMedia {
	my $catindex = shift;
	my @TempData = @_;
	my $path;
	if($catindex < 0) {
		$path = $WaitingPath.$slash."imagedata.cgi";
		#set this to the cat so when we approve it we know where it goes.
		$DesiredCat = "|".$cgi->param("Category")."\n";
	} else {
		$path = "$MediaPath$CategoryList[$catindex]->{PATH}imagedata.cgi";
		$DesiredCat = "\n";
	}
	$fh = OpenFile("$path", "append");
	print $fh "$TempData[0]|".
				"$TempData[1]|".
				"$TempData[2]|".
				"$TempData[3]|".
				"$TempData[4]|".
				"$TempData[5]|".
				"$TempData[6]|".
				"$TempData[7]|".
				"$TempData[8]|".
				"$TempData[9]|".
				"$TempData[10]|".
				"$TempData[11]".
				"$DesiredCat";
	CloseFile(\*$fh);	
	chmod(0666, "$path");
	IncCatImageCount($catindex);
	WriteMessage(qq~<p><b>Added $TempData[0] to $path<br>
	<blockquote>Filename : '$TempData[0]'<br>Thumbnail : '$TempData[1]'<br>User : '$TempData[10]'</blockquote></font></b></p>~);
}

###############################################################
# DeleteMedia
#	Deletes media data from proper category database
#	Unlinks file if specified or moves it back to waiting.
###############################################################

sub DeleteMedia {
	my $catindex = shift;
	my $filename = shift;
	my $deleteFromDisk = shift;
	if($catindex < 0) {
		$Path = $WaitingPath.$slash;
		ReadUserMediaWaiting();
		@MediaList = @UserMedia;
	} else {
		$Path = $MediaPath.$CategoryList[$catindex]->{PATH};
		ReadMedia($catindex);
	}
	
	$fh = OpenFile("$Path"."imagedata.cgi", "write");
	for(my $counter = 0; $counter < @MediaList; $counter++) {
		if($MediaList[$counter][$FILENAME] ne $filename) {
			print $fh $MediaList[$counter][0]."|".$MediaList[$counter][1]."|".$MediaList[$counter][2]."|".$MediaList[$counter][3]."|".
						$MediaList[$counter][4]."|".$MediaList[$counter][5]."|".$MediaList[$counter][6]."|".$MediaList[$counter][7]."|".
						$MediaList[$counter][8]."|".$MediaList[$counter][9]."|".$MediaList[$counter][10]."|".$MediaList[$counter][11]."\n";
		} else {
			$deleteThumb = $MediaList[$counter][$THUMBNAME];
		}
	}
	CloseFile(\*$fh);
	if($deleteFromDisk || $catindex < 0) {
		unless(unlink($Path."thumbs".$slash.$deleteThumb)) {
			WriteMessage("Unable to delete $deleteThumb<br>Reason: $!");
		} else {
			WriteMessage("Unlinked $deleteThumb");
		}
		unless(unlink($Path."media".$slash.$filename)) {
			WriteMessage("Unable to delete $filename<br>Reason: $!");
		} else {
			WriteMessage("Unlinked $filename");
		}			
	} else {
		MoveFile("$MediaPath$CategoryList[$catindex]->{PATH}media$slash$filename", $WaitingPath.$slash."media".$slash.$filename);
		MoveFile("$MediaPath$CategoryList[$catindex]->{PATH}thumbs$slash$deleteThumb", $WaitingPath.$slash."thumbs".$slash.$deleteThumb);
	}
	DecCatImageCount($catindex);

}

###############################################################
# IncrementDownload
#	EVIL EVIL BAD NAUGHTY JUNGLE OF LOVE!!
#	This baby likes to corrupt the image database.
#	Not much I can do, limitation of text files, if a visitor
#	hits stop while the function is writing, database is fuct.
###############################################################

sub IncrementDownload {
	my $catindex = shift;
	if(!@MediaList) {
		ReadMedia($catindex);
	}
	my $fileindex = shift;
	my $temp = int($MediaList[$fileindex][$DOWNLOADS]);
	$temp++;
	$MediaList[$fileindex][$DOWNLOADS] = $temp;
	if(@MediaList > 0) {
		WriteMedia($catindex);
	}
}
###############################################################
# ReadMediaWaiting
#	Compiles a list of files in the waiting directory that are
#	Not in the delayed posts list.
###############################################################

sub ReadMediaWaiting {
	my $dir = $WaitingPath.$slash."media";
	opendir (MEDIADIR, $dir) or FatalError("Can't open $dir for reading");
	@WaitingMedia = grep(!/^\.\.?$/, readdir (MEDIADIR)); 
	closedir(MEDIADIR);
	@WaitingMedia = sort @WaitingMedia;
	ReadUserMediaWaiting();
	for(my $j = 0; $j < @WaitingMedia; $j++) {
		for(my $k = 0; $k < @UserMedia; $k++) {
			if($WaitingMedia[$j] eq $UserMedia[$k][$filename]) {
				splice(@WaitingMedia, $j, 1);
			}				
		}
	}		  
	#WriteMessage("WaitingMedia looks like:");
	#for($counter = 0; $counter < @WaitingMedia; $counter++) {
	#	WriteMessage("$counter: $WaitingMedia[$counter]");
	#}
}

###############################################################
# ReadUserMediaWaiting
#	Reads in the list of media posted by users that require
#	Admin approval
###############################################################

sub ReadUserMediaWaiting {
	@UserMedia = ();
	if(!(-e $WaitingPath.$slash."imagedata.cgi")) {
		return;
	}
	$fh = OpenFile($WaitingPath.$slash."imagedata.cgi", "read");
	my(@MediaData) = ();
	my $mediacount = 0;
	while(<$fh>) {
		$line = $_;
		if($line =~ /^\[ArcadiaDB(.*?)\](.*)$/) {
			next;
		}
		chomp($line);
		@list = split('\|',$line);
		if($list[0] ne "" && $list[1] ne "") {
			push(@MediaData, $list[$FILENAME]);
			push(@MediaData, $list[$THUMBNAME]);
			push(@MediaData, $list[$TYPE]);
			push(@MediaData, $list[$DATE]);
			push(@MediaData, $list[$COPYRIGHT]);
			push(@MediaData, $list[$AUTHOR]);
			push(@MediaData, $list[$DOWNLOADS]);
			push(@MediaData, $list[$VOTES]);
			push(@MediaData, $list[$RATING]);
			push(@MediaData, $list[$DESCRIPTION]);
			push(@MediaData, $list[$USER]);
			push(@MediaData, $list[$IP]);
			if($list[12] ne "") {
				$MediaData[13] = $list[12];
			}
			$UserMedia[$mediacount] = [ @MediaData ];
			@MediaData=(); 
			$mediacount++;	
		}
	}
	#$UserMediaCount = $mediacounter;
	@UserMedia = sort ByFilename @UserMedia;
	#WriteMessage("WaitingMedia looks like:");
	#for(my $counter = 0; $counter < @UserMedia; $counter++) {
	#	WriteMessage("$UserMedia[$counter][0]");
	#}
}

###############################################################
# MoveFile
#	Moves any type of file to a new location from source
###############################################################

sub MoveFile {
	my $source = shift;
	my $dest = shift;
	WriteMessage("Copying from: $source to $dest");
	$sfh = OpenFile("$source", "read");
	$dfh = OpenFile("$dest", "write");
	binmode $dfh;
	binmode $sfh;
	while(read($sfh,$Buffer,1024)) {
		print $dfh $Buffer;
    }
	CloseFile(\*$sfh);
	CloseFile(\*$dfh);
	chmod(0666, $dest);
	unlink("$source");
}

sub MoveMedia {
	my $filename = shift;
	my $thumbnail = shift;
	my $sourceindex = shift;
	my $destindex = shift;
	my @NewData = @_;
						  
	#WriteMessage("NewData looks like: '$NewData[0]' '$NewData[1]' '$NewData[2]' '$NewData[3]' '$NewData[4]' '$NewData[5]'");
	if(!@CategoryList) {
		require $ScriptPath.$slash."categories.cgi";
		ReadCategories();
	}
	if($sourceindex < 0) {
		$SourceDir = $WaitingPath.$slash;
		$SourceName = "Waiting";
	} else {
		$SourceDir = "$MediaPath$CategoryList[$sourceindex]->{PATH}";
		$SourceName = "$CategoryList[$sourceindex]{NAME}";
	}
	$DestDir = "$MediaPath$CategoryList[$destindex]->{PATH}";
	my $temp = "$SourceDir"."imagedata.cgi";
	if(-e $temp) {
		$fh = OpenFile("$SourceDir"."imagedata.cgi", "read");
		my @ImageData = <$fh>;
		for(my $counter = 0; $counter < @ImageData; $counter++) {
			if($ImageData[$counter] =~ m/(.*?)$filename(.*)/g) {
				$MovedImageData = $ImageData[$counter];
				splice(@ImageData, $counter, 1);			
				@list = split(/\|/, $MovedImageData);
				if($thumbnail eq "") {
					$thumbnail = $list[$THUMBNAME];
				}
				WriteMessage("Removed entry for $filename from $SourceName");
				last;
			}
		}
		CloseFile(\*$fh);
		$fh = OpenFile("$SourceDir"."imagedata.cgi", "write");
		foreach $imagedata (@ImageData) {
			print $fh $imagedata;
		}
		CloseFile(\*$fh);
	}
	MoveFile("$SourceDir"."media$slash$filename", "$DestDir"."media$slash$filename");
	if($thumbnail) {
		MoveFile("$SourceDir"."thumbs$slash$thumbnail", "$DestDir"."thumbs$slash$thumbnail");
	}
	$fh = OpenFile("$DestDir"."imagedata.cgi", "append");
	if(@NewData) {
		$temp = $NewData[0]."|".$NewData[1]."|".$NewData[2]."|".$NewData[3]."|".$NewData[4]."|".$NewData[5]."|".
					$NewData[6]."|".$NewData[7]."|".$NewData[8]."|".$NewData[9]."|".$NewData[10]."|".$NewData[11]."|".
					$NewData[12]."\n";
		print $fh $temp;
		#WriteMessage("Writing: $temp");
	} else {
		print $fh $MovedImageData;
		#WriteMessage("Writing $MovedImageData to file.");
	}
	CloseFile(\*$fh);
	chmod(0666, "$DestDir"."imagedata.cgi");
	if($sourceindex >= 0) {
		DecCatImageCount($sourceindex);
	}
	IncCatImageCount($destindex);
	WriteMessage("Moved $filename from $SourceName to $CategoryList[$destindex]->{NAME}");
}

###############################################################
# Upload
#	Checks User rights...
###############################################################

sub Upload {
	if(GetPermission("Upload")) {
		UploadImage($cgi->param("Category"));
	} elsif(GetPermission("UploadDelayed")) {
		UploadImage(-1);
	} else {
		if($Username) {
			FatalError("$Username, You do not have permission to upload media to this gallery.");
		} else {
			FatalError("You do not have permission to upload media to this gallery.");
		}
	}
}

###############################################################
# UploadImage
#	Does the work...
###############################################################

sub UploadImage
{
	my $Index = shift;
	if($Index < 0) {
		$BasePath = "$WaitingPath$slash";
		$BaseUrl = "$WaitingUrl/";
	} else {
		$BasePath = $MediaPath.$CategoryList[$cgi->param("Category")]->{PATH};
		$BaseUrl = $MediaUrl.$CategoryList[$cgi->param("Category")]->{PATH};
	}
	my $ThumbPath = $BasePath."thumbs$slash";
	my $ThumbUrl = $BaseUrl."thumbs/";
	my $NewMediaPath = $BasePath."media$slash";
	my $NewMediaUrl = $BaseUrl."media/";
	#Flush the buffers...
	$| = 1;
	if ($cgi->param("filename") =~ /([^\/\\]+)$/) {
		$filename = $1;
		$filename =~ s/^\.+//;
		$File_Handle = $cgi->param("filename");
		#first lets get rid of the spaces...
		$filename = join('', split(/ */, $filename));
		#now rename if file already exists...
		$num = 0;
		$tempname = $filename;
		@parts = split('\.', $tempname);
		while ( -e "$NewMediaPath$tempname") {
            # rename to a better one so as not to overwrite an existing image.
			 $tempname = $parts[0].$num.'.'.$parts[1];
			 $num++;
		}
		$filename = $tempname;
		#print "Filename is : ".$filename."<br>";
		#print "Filehandle is : ".$File_Handle."<br>";
	} else {
		$badfile = $cgi->param("filename");
		$message = "You attempted to upload a file that isn't properly formatted.  The file in question is <b>$badfile</b> Please rename the file on your computer, and	attempt to upload it again.  Files may not have forward or backward slashes in their names and they may not be prefixed with one (or more) periods. Press the back button on your browser to return to the upload screen.";
		FatalError($message);
		exit;
	}
	if($cgi->param("thumbnail") =~ /([^\/\\]+)$/) {
		$thumbnail = $1;
		$thumbnail =~ s/^\.+//;
		$Thumb_Handle = $cgi->param("thumbnail");
		#rid of spaces
		$thumbnail = join('', split(/ */, $thumbnail));
		#rename it, if it exists
		$num = 0;
		$tempname = $thumbnail;
		@parts = split('\.', $tempname);
		while ( -e "$ThumbPath$tempname") {
            # rename to a better one so as not to overwrite an existing image.
			 $tempname = $parts[0].$num.'.'.$parts[1];
			 $num++;
		}
		$thumbnail = $tempname;
		#print "Thumbnail is : ".$thumbnail."<br>";
		#print "Thumbhandle is : ".$Thumb_Handle."<br>";
		$CreateThumb = "false";
	} else {
		my($file, $ext) = split('\.', $filename);
		$thumbnail = $ThumbPrefix.$file.$ThumbSuffix.".".$ext;
		$CreateThumb = "true";
	}
	
	if (!open(BIGOUT, ">$NewMediaPath$filename")) {
		$message = qq~
        <p>
        -------------------------<br>
        Error:<br>
        -------------------------<br>
        File: $NewMediaPath$filename<br>
        -------------------------<p>
	    Please contact the gallery administrator.  There was an error opening the Output File
    	for Writing.<br>
		Make sure that the directory:<p>
		$ThumbPath<p>
    	has been chmodded with the permissions '777' and that there is enough free disk space left.<p>
		The Error message below should help you diagnose the problem.<p>
        Error: $!<p>
		~;
        exit;
	}
	if($CreateThumb ne "true" && !open(SMALLOUT, ">$ThumbPath$thumbnail")) {
		$message = qq~
		<p>
        -------------------------<br>
        Error:<br>
        -------------------------<br>
        File: $ThumbPath$thumbnail<br>
        -------------------------<p>
	    Please contact the gallery administrator.  There was an error opening the Output File
    	for Writing.<br>
		Make sure that the directory:<p>
		$ThumbPath<p>
    	has been chmodded with the permissions '777' and that there is enough free disk space left.<p>
		The Error message below should help you diagnose the problem.<p>
        Error: $!<p>
		~;
		FatalError($message);
        exit;
	}
	binmode(BIGOUT);
	if($CreateThumb ne "true") {
		binmode(SMALLOUT);
	}

	undef $BytesRead;
	undef $Buffer;
    while ($Bytes = read($File_Handle,$Buffer,1024)) {
		$BytesRead += $Bytes;
		print BIGOUT $Buffer;
    }
	#print "wrote image";
	push(@Files_Written, "$NewMediaPath$filename");
    close($File_Handle);
	close(BIGOUT);
    chmod (0666, "$NewMediaPath$filename");

	if($CreateThumb ne "true") {
		undef $Buffer;
		undef $Bytes;
	    while ($Bytes = read($Thumb_Handle,$Buffer,1024)) {
			$BytesRead += $Bytes;
			print SMALLOUT $Buffer;
		}
		#print "wrote image";
		push(@Files_Written, "$ThumbPath$thumbnail");
		close($Thumb_Handle);
		close(SMALLOUT);
		chmod (0666, "$ThumbPath$thumbnail");
	}

	$MediaType = AssignType("$filename");

	if ($BytesRead > $MaxUpload && $MaxUpload > 0) {
		unlink "$NewMediaPath$filename";
		unlink "$ThumbPath$thumbnail";
		$message = qq~
		You have reached your upload limit.  You attempted to upload images totalling 
		<B>$BytesRead</B>.  This exceeds the maximum limit of <B>$maxupload</B> bytes, set by the gallery
		administrator.  Your upload was <B>unsuccessful</B>.  Please try a smaller file.  Press the back button on your browser to return to the upload screen.
		<P>
		~;
		FatalError($message);
		exit;
	}
	
	#assemble data for database..
	#print "setting up data.<br>";
	push(@NewData, $filename);
	push(@NewData, $thumbnail);
	push(@NewData, $MediaType);
	push(@NewData, GetDateTime());
	if($cgi->param("copyright") eq "") {
		push(@NewData, "NODATA");
	} else {
		push(@NewData, DecodeURL($cgi->param("copyright")));
	}
	if($cgi->param("author") eq "") {
		push(@NewData, "NODATA");
	} else {
		push(@NewData, DecodeURL($cgi->param("author")));
	}
	push(@NewData, 0);
	push(@NewData, 0);
	push(@NewData, 0);
	if($cgi->param("description") eq "") {
		push(@NewData,"No Description");
	} else {
		push(@NewData, DecodeURL($cgi->param("description")));
	}
	push(@NewData, $cgi->param("username"));
	push(@NewData, $ENV{'REMOTE_ADDR'});

	#Run Image Processing Plugins
	eval { require "$ScriptPath/plugins.cgi"; };
	LoadPlugins();
	if(@Plugins_ImageProcessing) {
		@Arguments = ($NewMediaPath.$filename, $ThumbPath.$thumbnail, $CreateThumb);
		RunPlugins([@Plugins_ImageProcessing], [@Arguments]);
	}
	#Go ahead and add image to the database.
	AddMedia($Index ,@NewData);
														  
	$message = "<b>This is the information we received:</b><p align=\"center\"";
	$message = $message."Username : ".$NewData[$USER]."<br>";
	$message = $message."IP : ".$NewData[$IP]."<br>";
	$message = $message."Image : ".$filename."<br><img src=\"".$NewMediaUrl.$filename."\" border=\"1\"><br>";
	$message = $message."Thumbnail : ".$thumbnail."<br><img src=\"".$ThumbUrl.$thumbnail."\" border=\"1\"><br>";
	$message = $message."Description : ".$NewData[$DESCRIPTION]."<br>";
	$message = $message."Copyright : ".$NewData[$COPYRIGHT]."<br>";
	$message = $message."Author : ".$NewData[$AUTHOR]."<br>";
	$message = $message."<P><B>$BytesRead</B> total bytes uploaded.<p>";
	
	Success($message);
}

sub AssignType {
	ReadFileTypes();
	my($file) = @_;
	$ext = GetFileExt($file);
	if($FileClass{lc($ext)} ne "") {
		return $FileClass{lc($ext)};
	} else {
		return "Unknown";
	}
}		

#returns the file extension
sub GetFileExt {
	my ($file) = @_;
	@parts = split('\.', $file);
	return $parts[1];
}

#for detecting the type of file being uploaded.
sub GetFileType {
    my ($file) = @_;
    my ($gifid, $jpgid, $gifflg, $jpgflg, $retval, $nn, $xx, $counter);
    open (TEST, "<$file") or return ($retval='unable to open'); 
    read (TEST, $xx, 15) or return ($retval='unable to read');
    close TEST;
    $gifid = '474946383961000000000000';
    $jpgid = 'ffd8ffe000104a4649460001';
    $gifflg = 'T';
    $jpgflg = 'T';
    $retval = 'unknown';
    for ($counter=0; $counter < 12; $counter++) {
        $nn = unpack ("H2", substr($xx, $counter, 1));
        if ($counter < 6) {
            if ($nn ne substr($gifid, ($counter * 2), 2)) {
				$gifflg = 'F';
			}
		}
        if ($nn ne substr($jpgid, ($counter * 2), 2)) {
			$jpgflg = 'F';}
        # this line is for testing jpgid accuracy print "$nn,$gifflg$jpgflg ";
        }
    if ($gifflg eq 'T') {$retval = 'GIF';}
    if ($jpgflg eq 'T') {$retval = 'JPEG';}
    return $retval;

} # end of sub

1;