##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# memory.cgi

###############################################################
# LoadProfile()
# Returns @UserProfiel in the format of :
#	[0]  Username
#	[1]  Password
#	[2]  Email Address
#	[3]  ICQ Number *
#	[4]  AOL Screen Name *
#	[5]  Web Site *
#	[6]  Location *
#	[7]  Time Zone *
#	[8]  Interests *
#	[9]  Signature *
#	[10] Avatar *
#	[11] Default Sort
#	[12] Last Visited
#	[13] Show Email *
#	[14] Date Registered
#	[15] Access Rights (config|post|view|delete|admin)
#	[16] Group Member (groupname)
#	[17] Number of Posts (438) *
# * not currently implemented.
###############################################################

###############################################################
# Access Right constants used in GetPermission
#	AccessAdmin
#	EditGeneral
#	EditCategories
#	AddNewMedia
#	EditMedia
#	ManageFileTypes
#	ModifyStyle
#	ImageDisplay
#	EditUsers
#	EditGroups
#	Upload
#	UploadDelayed
###############################################################

###############################################################
# LoadProfile()
#	Loads user profile from disk into @UserProfile.
#	returns
#	- dne if user does not exist
#	- false if passwords and usernames don't match
#	- true otherwise
###############################################################

sub LoadProfile {
	my $name = shift;
	if($name eq "") {
		$name = $Username;
	}
	@UserProfile = ();
	if($name ne "") {
	# Load user settings
		$Number = GetUserNumber($name);
		if(-e($MemberPath.$slash."$Number.cgi")) {
			@UserProfile = ();
			$fh = OpenFile($MemberPath.$slash."$Number.cgi", "read");
			@UserProfile = <$fh>;
			CloseFile(\*$fh);
			foreach $entry (@UserProfile) {
				$entry =~ s/\n//g;
				$entry =~ s/\r//g;
			}
			if($name ne $UserProfile[0]) {
				return "dne";
			}
			#Split up the permissions into array elements
			@UserRights = split(/ */, $UserProfile[15]);
			@UserGroups = split(/\|/, $UserProfile[16]);
			#WriteMessage("User is a member of these groups : ");
			#foreach $group (@UserGroups) {
			#	WriteMessage("UserGroup: $group");
			#}
			#foreach $right (@UserRights) {
			#	WriteMessage("UserRight: $right");
			#}
		} else {
			return "dne";
		}
	}
}

sub SaveProfile {
	$Number = GetUserNumber($UserProfile[0]);
	if(-e($MemberPath.$slash."$Number.cgi")) {
		$fh = OpenFile($MemberPath.$slash."$Number.cgi", "write");
		foreach $entry (@UserProfile) {
			print $fh $entry."\n";
		}
		CloseFile(\*$fh);
		WriteMessage("User Profile for $UserProfile[0] saved.");
	} else {
		FatalError("Could not save profile for $UserProfile[0]!<br>Reason: $MemberPath/$Number.cgi does not exist.");
	}
}

sub GetPermission {
	if(!@UserRights) { LoadProfile(); }
	my $perm = shift;
	my $index = -1;
	if($perm eq "AccessAdmin") { $index = 0; }
	if($perm eq "EditGeneral") { $index = 1; }
	if($perm eq "EditCategories") { $index = 2; }
	if($perm eq "AddNewMedia") { $index = 3; }
	if($perm eq "EditMedia") { $index = 4; }
	if($perm eq "ManageFileTypes") { $index = 5; }
	if($perm eq "ModifyStyle") { $index = 6; }
	if($perm eq "ImageDisplay") { $index = 7; }
	if($perm eq "EditUsers") { $index = 8; }
	if($perm eq "EditGroups") { $index = 9; }
	if($perm eq "Upload") { $index = 10; }
	if($perm eq "UploadDelayed") { $index = 11; }
	if($index == -1) { WriteMessage("Unknown Permission requested."); }
	if($UserRights[$index] == 1) { return 1; }
	if(!%Groups) {
		LoadGroupSettings();
	}
	foreach $group (@UserGroups) {
		if($Groups{$group}[$index] == 1) { return 1; }
	}
	return 0;
}

sub GetPermissionFatal {
	my $perm = shift;
	my $index = -1;
	if($perm eq "AccessAdmin") { $index = 0; }
	if($perm eq "EditGeneral") { $index = 1; }
	if($perm eq "EditCategories") { $index = 2; }
	if($perm eq "AddNewMedia") { $index = 3; }
	if($perm eq "EditMedia") { $index = 4; }
	if($perm eq "ManageFileTypes") { $index = 5; }
	if($perm eq "ModifyStyle") { $index = 6; }
	if($perm eq "ImageDisplay") { $index = 7; }
	if($perm eq "EditUsers") { $index = 8; }
	if($perm eq "EditGroups") { $index = 9; }
	if($perm eq "Upload") { $index = 10; }
	if($perm eq "UploadDelayed") { $index = 11; }
	if($index == -1) { FatalError("Unknown Permission requested."); }
	if($UserRights[$index] == 1) { return; }
	if(!%Groups) {
		LoadGroupSettings();
	}
	foreach $group (@UserGroups) {
		if($Groups{$group}[$index] == 1) { return; }
	}
	FatalError("$Username, You do not have permission to access this area.");
	
}

sub GetUserNumber {
	$name = shift;
	$fh = OpenFile($MemberPath.$slash."userlist.cgi", "read");
	my $number = "dne";
	while(<$fh>) {
		@line = split(/\|/, $_);
		if($line[0] eq $name) {
			$number = $line[1];
			chomp($number);
			last;
		}
	}
	CloseFile(\*$fh);
	return $number;	
}

sub LoadEmailList {
	unless(-e $MemberPath.$slash."emaillist.cgi") { 
		return;
	}
	@EmailList = ();
	$fh = OpenFile($MemberPath.$slash."emaillist.cgi", "read");
	while(<$fh>) {
		@line = split(/\|/, $_);
		push(@EmailList, $line[0]);
	}
	CloseFile(\*$fh);
}

sub LoadUserList {
	unless(-e $MemberPath.$slash."userlist.cgi") { 
		$LastNumber = 0;
		return;
	}
	$fh = OpenFile($MemberPath.$slash."userlist.cgi", "read");
	@UserList = ();
	@NumberList = ();
	while(<$fh>) {
		$line = $_;
		chomp($line);
		@entries = split(/\|/, $line);
		push(@UserList, $entries[0]);
		push(@NumberList, $entries[1]);
	}
	CloseFile(\*$fh);
	@NumberList = sort @NumberList;
	@rNumberList = reverse(@NumberList);
	$LastNumber = $rNumberList[0];
}

sub UserExists {
	$check = shift; 
	LoadUserList();
	my $found = "false";
	for(my $counter = 0; $counter < @UserList; $counter++) {
		if($check eq $UserList[$counter]) {
			$found = "true";
			$UserIndex = $counter;
			last;
		}			
	}
	return $found;
}

sub EmailExists {
	$check = shift;
	LoadEmailList();
	my $found = "false";
	for(my $counter = 0; $counter < @EmailList; $counter++) {
		if($check eq $EmailList[$counter]) {
			$found = "true";
			$UserIndex = $counter;
			last;
		}			
	}
	return $found;
}

sub GetFullUserList {
	LoadUserList();
	@Results = ();
	for(my $counter = 0; $counter < @UserList; $counter++) {
		LoadProfile($UserList[$counter]);
		@Results[$counter] = [ @UserProfile ];
	}		
}

sub FindUserByEmail {
	my $searchemail = shift;
	LoadUserList();
	@Results = ();
	if(EmailExists($searchemail) ne "false") {
		LoadProfile($UserList[$UserIndex]);
		@Results[0] = [ @UserProfile ];
	}
}

sub FindUserByUsername {
	my $searchuser = shift;
	@Results = ();
	if(UserExists($searchuser) ne "false") {
		LoadProfile($searchuser);
		@Results[0] = [ @UserProfile ];
	}
}
	
sub InsertUser {
	my $perm = shift;
	my $groups = shift;
	if($groups eq "") {
		$groups = $DefaultGroup;
	}
	$AddOne = $LastNumber + 1;
	$NextNumber = sprintf("%8d", $AddOne);
	$NextNumber =~ tr/ /0/;
	GetDateTime();
	$fh = OpenFile($MemberPath.$slash."$NextNumber.cgi", "write");
	print $fh "$username\n";
	print $fh "$password\n";
	print $fh "$email\n";
	print $fh "\n";
	print $fh "$name\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "\n";
	print $fh "$DateTime\n";
	print $fh "$perm\n";
	print $fh "$groups\n";
	print $fh "0\n";
	CloseFile(\*$fh);
	chmod(0666, $MemberPath.$slash."$NextNumber.cgi");

	$fh = OpenFile($MemberPath.$slash."userlist.cgi", "append");
	print $fh "$username\|$NextNumber\n";
	CloseFile(\*$fh);
	chmod(0666, $MemberPath.$slash."userlist.cgi");

	$fh = OpenFile($MemberPath.$slash."emaillist.cgi", "append");
	print $fh "$email\|$NextNumber\n";
	CloseFile(\*$fh);
	chmod(0666, $MemberPath.$slash."emaillist.cgi");
}

sub DeleteUser {
	my $user = shift;
	my $number = GetUserNumber($user);
	$ul = OpenFile($MemberPath.$slash."userlist.cgi", "read");
	$el = OpenFile($MemberPath.$slash."emaillist.cgi", "read");
	@UserList = <$ul>;
	@EmailList = <$el>;
	CloseFile(\*$ul);
	CloseFile(\*$el);
	$ul = OpenFile($MemberPath.$slash."userlist.cgi", "write");
	$el = OpenFile($MemberPath.$slash."emaillist.cgi", "write");
	foreach $user (@UserList) {
		if($user !~ m/(.*?)$number(.*?)/ && $user ne "") {
			print $ul $user;
		}
	}
	foreach $email (@EmailList) {
		if($email !~ m/(.*?)$number(.*?)/ && $email ne "") {
			print $el $email;
		}
	}
	unlink($MemberPath.$slash."$number.cgi");
	CloseFile(\*$ul);
	CloseFile(\*$el);
	WriteMessage("User: $user has been deleted.");
}

sub LoadGroupSettings {
	@Groups = ();
	unless(-e $MemberPath.$slash."groups.cgi") { 
		return;
	}
	$fh = OpenFile($MemberPath.$slash."groups.cgi", "read");
	my $counter = 0;
	while(<$fh>) {
		$line = $_;
		chomp($line);
		@temp = split(/\|/, $line);
		@permissions = split(/ */, $temp[1]);
		$Groups{$temp[0]} = [ @permissions ];
	}
	CloseFile(\*$fh);
	#my @keys = keys(%Groups);
	#foreach $key (@keys) {
	#	WriteMessage("$key");
	#}
}

sub WriteGroupSettings {
	$fh = OpenFile($MemberPath.$slash."groups.cgi", "write");
	@keys = keys(%Groups);
	foreach $key (@keys) {
		print $fh $key."|";
		for(my $counter = 0; $counter < 12; $counter++) {
			print $fh $Groups{$key}[$counter];
		}
		print $fh "\n";
	}
	CloseFile(\*$fh);
}

sub CreateNewGroup {
	LoadGroupSettings();
	my $NewGroup = DecodeURL($cgi->param("group"));
	@keys = keys(%Groups);
	foreach $key (@keys) {
		if($key eq $NewGroup) {
			FatalError("Unable to create new group!<br>Reason: A group with the same name already exists!");
		}
	}
	my @permissions = "";
	if($cgi->param("AdminAccess") eq "ON") {
		$permissions[0] = "1";
	} else {
		$permissions[0] = "0";
	}
	if($cgi->param("EditGeneralSettings") eq "ON") {
		$permissions[1] = "1";
	} else {
		$permissions[1] = "0";
	}
	if($cgi->param("EditCategories") eq "ON") {
		$permissions[2] = "1";
	} else {
		$permissions[2] = "0";
	}
	if($cgi->param("AddNewMedia") eq "ON") {
		$permissions[3] = "1";
	} else {
		$permissions[3] = "0";
	}
	if($cgi->param("EditMedia") eq "ON") {
		$permissions[4] = "1";
	} else {
		$permissions[4] = "0";
	}
	if($cgi->param("ManageFileTypes") eq "ON") {
		$permissions[5] = "1";
	} else {
		$permissions[5] = "0";
	}
	if($cgi->param("ModifyStyle") eq "ON") {
		$permissions[6] = "1";
	} else {
		$permissions[6] = "0";
	}
	if($cgi->param("ModifyImageDisplay") eq "ON") {
		$permissions[7] = "1";
	} else {
		$permissions[7] = "0";
	}
	if($cgi->param("EditUsers") eq "ON") {
		$permissions[8] = "1";
	} else {
		$permissions[8] = "0";
	}
	if($cgi->param("EditGroups") eq "ON") {
		$permissions[9] = "1";
	} else {
		$permissions[9] = "0";
	}
	if($cgi->param("UploadMedia") eq "ON") {
		$permissions[10] = "1";
	} else {
		$permissions[10] = "0";
	}
	if($cgi->param("UploadMediaWithWait") eq "ON") {
		$permissions[11] = "1";
	} else {
		$permissions[11] = "0";
	}
	$Groups{$NewGroup} = [ @permissions ];
	WriteGroupSettings();
}

sub SaveGroupChanges {
	LoadGroupSettings();
	my $NewGroup = DecodeURL($cgi->param("group"));	
	my @permissions = "";
	if($cgi->param("AdminAccess") eq "ON") {
		$permissions[0] = "1";
	} else {
		$permissions[0] = "0";
	}
	if($cgi->param("EditGeneralSettings") eq "ON") {
		$permissions[1] = "1";
	} else {
		$permissions[1] = "0";
	}
	if($cgi->param("EditCategories") eq "ON") {
		$permissions[2] = "1";
	} else {
		$permissions[2] = "0";
	}
	if($cgi->param("AddNewMedia") eq "ON") {
		$permissions[3] = "1";
	} else {
		$permissions[3] = "0";
	}
	if($cgi->param("EditMedia") eq "ON") {
		$permissions[4] = "1";
	} else {
		$permissions[4] = "0";
	}
	if($cgi->param("ManageFileTypes") eq "ON") {
		$permissions[5] = "1";
	} else {
		$permissions[5] = "0";
	}
	if($cgi->param("ModifyStyle") eq "ON") {
		$permissions[6] = "1";
	} else {
		$permissions[6] = "0";
	}
	if($cgi->param("ModifyImageDisplay") eq "ON") {
		$permissions[7] = "1";
	} else {
		$permissions[7] = "0";
	}
	if($cgi->param("EditUsers") eq "ON") {
		$permissions[8] = "1";
	} else {
		$permissions[8] = "0";
	}
	if($cgi->param("EditGroups") eq "ON") {
		$permissions[9] = "1";
	} else {
		$permissions[9] = "0";
	}
	if($cgi->param("UploadMedia") eq "ON") {
		$permissions[10] = "1";
	} else {
		$permissions[10] = "0";
	}
	if($cgi->param("UploadMediaWithWait") eq "ON") {
		$permissions[11] = "1";
	} else {
		$permissions[11] = "0";
	}
	$Groups{$NewGroup} = [ @permissions ];
	WriteGroupSettings();
}

sub DeleteGroup {
	my $groupname = shift;
	unless ( -e $MemberPath.$slash."groups.cgi") {
		return;
	}
	$fh = OpenFile($MemberPath.$slash."groups.cgi", "read");
	my @GroupList = <$fh>;
	CloseFile(\*$fh);
	$fh = OpenFile($MemberPath.$slash."groups.cgi", "write");
	foreach $group (@GroupList) {
		if($group !~ m/(.*?)$groupname(.*?)/ && $group ne "") {
			print $fh $group;
		}
	}
	CloseFile(\*$fh);
	WriteMessage("Deleted Group: $groupname.");
}

sub Login {
	FatalError("You forgot to fill in the Username Field!") if($cgi->param('username') eq "");
	FatalError("You forgot to fill in the Password Field!") if($cgi->param('password') eq "");
	$Username = $cgi->param('username');
	$Password = $cgi->param('password');
	my $rval = LoadProfile();
	if($rval eq "dne") {
		FatalError("Sorry, The Username: $Username does not exist in our records.");
	}
	if($Password ne $UserProfile[1]) {
		return "false";
	} else {
		$LoggedIn = "true";
		SetCookie(PrepareCookie());
		return "true";
		#WriteMessage("Welcome back $Username, you have been logged in.");
	}
}

sub CheckExistingLogin {
	my $rval = LoadProfile();
	if($rval eq "dne") {
		return "dne";
	}
	if($Password ne $UserProfile[1]) {
		return "false";
	} else {
		$LoggedIn = "true";
		SetCookie(PrepareCookie());
		return "true";
		#WriteMessage("Welcome back $Username, you have been logged in.");
	}
}

sub Logout {
	$LoggedIn = "false";
	$Username = "";
	$Password = "";
	SetCookie(PrepareCookie());
	WriteMessage("You have been logged out of the system.");
}

###########################################################

sub ViewProfile {
	
}

sub ShowEditProfile {

}

sub EditProfile {

}

###########################################################

sub Register {
	FatalError("You did not fill out the username field, this is a required entry.") if($cgi->param('username') eq "");
	FatalError("Username contains invalid characters.  It may only contain alpha-numerics.") if($cgi->param('username') =~ " ");
	FatalError("The password field is empty.") if($cgi->param('password') eq "");
	FatalError("The name field is empty, this is a required entry.") if($cgi->param('name') eq "");
	FatalError("The email field is empty, this is a required entry.") if($cgi->param('email') eq "");

	$username = $cgi->param('username');
	$email = $cgi->param('email');
	if (($username =~ m/^\s/) || 
		($username =~ m/\&nbsp/) || 
		($username =~ m/\s$/) || 
		($username =~ m/\s{2,}/) || 
		($username =~ m/\|\!/) || 
		($username =~ m/\|/) || 
		($username =~ m/\|$/) || 
		($username =~ m/^\|/) || 
		($username =~ m/\"/) || 
		($email =~ m/\s/) || 
		($username =~ m/>|</) || 
		($username =~ m/memberslist/) || 
		($username =~ m/emailfile/) ||  
		($username =~ m/;/)  || 
		($username !~ /^[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']/) || 
		($username !~ /[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']$/) ) {

		my $message = qq~
		<p>The User Name you attempted to register is illegal for one of the following reasons:<P>
		<blockquote>1.  You may not begin or end a User Name with a space. 
		<P>2. You may not have two or more consecutive spaces.
		<p>3. You may not use a name with a pipestem followed by an exclamation point.
		<P>4. You may not use a name with a pipestem.
		<p>5. You may not use any quotation marks.
		<P>6. Your email address must not contain any spaces.
		<P>7. You may not use a name that contains a &lt; and a &gt; .
		<P>8. You may not use a name that contains memberslist or emailfile.
		<P>9. You must start and end your username with an English letter or number or one of the following symbols: !, ?, #, $, @, *, &, ^, +, -, \~, :, ], [, '.
		<P>10. You may not include a semicolon.
		</B></blockquote><p><CENTER>Use your back button to try again.</center>~;
		FatalError($message);
	}
	if(UserExists($username) eq "true") {
		FatalError("Sorry, but that Username already exists.");
	}
	if(EmailExists($email) eq "true") {
		FatalError("Sorry, but that Email aready exists.");
	}
	$name = $cgi->param("name");
	$password = $cgi->param("password");
	InsertUser();
	$Username = $cgi->param('username');
	$Password = $cgi->param('password');
	$LoggedIn = "true";
	SetCookie(PrepareCookie());
	Success("Registeration complete.<p>You have been logged in and may continue.");
	exit;
}

sub LoadUserJavaCode {
	my($html) = qq~
	<SCRIPT LANGUAGE="JavaScript">
	  <!-- cloak
	  var dc = document.cookie;
	  var testUserName = getCookie("Username");
	  var testPassword = getCookie("Password");
	  if (document.cookie) {
	    if (testUserName == null || testUserName == "x") {  
			document.FORM.username.focus();
		} else {
			document.FORM.username.value = testUserName;
			document.FORM.password.value = testPassword;
		}
	  }  else {
		document.FORM.username.focus();
	  }
		function getCookie(name){
			var cname = name + "=";               
			var dc = unescape(document.cookie);
			if (dc.length > 0) {              
				begin = dc.indexOf(cname);
				if (begin != -1) {           
					begin += cname.length;
					end = dc.indexOf("|", begin);
		            if (end == -1) end = dc.length; {
						return unescape(dc.substring(begin, end));
					}
				} 
			}
			return null;
		}
		// decloak -->
		</SCRIPT>
		~;
	return $html;
}

sub CrumbleCookie() {
	@vars=split(/\|/,$CookieData);
	foreach $var (@vars) {
		@pair=split(/=/,$var);
		$evalstr='$'.$pair[0].'=';
		$evalstr.="\"$pair[1]\"";
		eval ($evalstr);
	}
}

sub PrepareCookie() { 
	#if($Username ne "" || $Username ne "x") {
	#	$CookieData = $CookieData."Username=$Username|";
	#}
	#if($Password ne "" || $Password ne "x") {
	#	$CookieData = $CookieData."Password=$Password|";
	#}
	#$CookieData = $CookieData."LoggedIn=$LoggedIn|".
	#			"SortBy=$SortBy";
	$CookieData = "Username=$Username|".
				"Password=$Password|".
				"LoggedIn=$LoggedIn|".
				"SortBy=$SortBy";

   return $CookieData;
}

sub SetCookie($CookieData) {
	my($FinalCookie) = $cgi->cookie(-name=>$CookieName,
								-value=>$CookieData,
								-path=>'/',
								#-domain=>'.eden.matrix'
								#-domain=>$GalleryUrl,
								#-path=>$GalleryUrl,
								-expires=>$CookieExpires);

	print $cgi->header(-cookie=>$FinalCookie);
	$HeaderPrinted = "true";
}

1;

