##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# plugins.cgi

########################################################################################
#So far the hooks we have are:
# @Plugins_Loaded
# @Plugins_Desc
# @Plugins_Version
#	Every plugin needs to store its name, description, and version in these arrays.
#
# @Plugins_ImageProcessing
#	These hooks are called on file upload to create thumbnails or any watermarks
#	They are passed the full filename of the large file and full filename of thumbnail desired
#	Any image processing function should return 1 on a creation of thumbnail
#	or a 0 if the thumbnail was not created.
#
# @Plugins_UploadOptions
#	This hooks into the HTML diplayed when the upload page is shown.  Any options
#	needed can be shown through functions here.
#
# @Plugins_ViewConfig
#	If there are any options to setup, they will be displayed in these functions
#
# @Plugins_SaveConfig
#	Called after ViewConfig is done.  Basically allows for the plugin to save its data
#
########################################################################################
LoadPlugins();

sub LoadPlugins {
	opendir(DIR, $ScriptPath);
		my @entries = readdir(DIR);
	closedir(DIR);
	my $direntry;
	foreach $direntry (@entries) {
		if ($direntry =~ /iap_\S+\.pl/) {
			eval { require $ScriptPath.$slash.$direntry; };
			if ($@) {
				FatalError("Error loading plugin $direntry.<p>If you continue to experience this error, delete the file $direntry from your $ScriptPath directory.<p>The exact error produced was: $@.");
			}
		}
	}
	$PluginsLoaded = 1;
}

########################################################################################
# RunPlugins
#	Takes 2 arrays as parameters, a list of functions to call and a list of Arguments
#	to pass to the functions.
########################################################################################

sub RunPlugins {
	my $counter = 0;
	my @PluginList;
	my @Arguments;
	foreach $aref ( @_ ) {
		if($counter == 0) {
			@PluginList = @$aref;
			$counter++;
		} elsif($counter == 1) {
			@Argument = @$aref;
			$counter++;
		}
	}				
	my $PluginSub;
	my($return);
	#WriteMessage("Plugin[0] is $PluginList[0]");
	#foreach $arg (@Argument) {
	#	WriteMessage("Arg is $arg");
	#}
	foreach $PluginSub (@PluginList) {
		#WriteMessage("Calling $PluginSub");
		unless ($PluginFailure) {
			eval { $return = $return.&$PluginSub(@Argument); };
			if ($@) {
				$PluginFailure = 1;
				FatalError("Error running plugin subroutine $PluginSub.<p>If you continue to experience this error, remove the appropriate Plugin.<p>Error: $@");
			}
		}
	}
	return $return;
}

1;
