##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# template.cgi
#  needs SkinName/gallery.html
#  needs SkinName/categorylisting.html
#  needs SkinName/media.html
#  needs SkinName/blank.html

sub GalleryTemplate {
	my($filename) = $SkinPath.$slash.$CategoryList[$CategoryIndex]->{SKIN}.$slash."gallery.html";
	if(!(-e $filename)) {
		$filename = $SkinPath.$slash.$DefaultSkin.$slash."gallery.html";
	}
	$fh = OpenFile($filename, "read");
	@template = <$fh>;
	CloseFile(\*$fh);

	CalcExistingPages();
	$NumPictures = @MediaList;
	if($NumPictures > $MaxPerPage && $Page > 1) {
		if($TotalPages < $Page) {
			FatalError("Page does not exist!");
		}
	}
	$Index = ($Page - 1) * $MaxPerPage;
	$PicsOnPage = $NumPictures - $Index;
	if($PicsOnPage > $MaxPerPage - 1) {
		$PicsOnPage = $MaxPerPage;
	}	
	foreach $line (@template) {
		#if($line =~ /!IA_THUMB/) {
		if($line =~ /^(.*?)!IA_THUMB(.*)$/) {
			$line = $1;
			my(@index) = split(/:/, $2);
			#$line = $line."1: $1<br>2: $2<br>3: $3<br>";
			#foreach $var (@index) {
			#	$line = $line."<b>$var<br>";
			#}
			$line = $line.ThumbHTML(int($index[1])+$Index);
			$line = $line.$3;
		}
		if($line =~ /^(.*?)!IA_FIELD(.*)$/) {
			$line = $1;
			my(@index) = split(/:/, $2);
			#$line = $line."1: $1<br>2: $2<br>3: $3<br>";
			#foreach $var (@index) {
			#	$line = $line."<b>$var<br>";
			#}
			$line = $line.MediaField(int($index[1])+$Index, int($index[2]));
			$line = $line.$3;
		}
	}
	my($resultPage) = join("",@template);
	$catinline = CategoryInline();
	$catbox = CategoryDropBox();
	$cattree = CategoryTree();
	$pagenav = PageNavigation();
	$stats = PageStats();
	$sort = SortDropBox();
	$user = UserOptions();
	$thumbtable = ThumbTable();

	$resultPage =~ s/!IA_CATEGORY_INLINE_NAV/$catinline/g;
	$resultPage =~ s/!IA_CATEGORY_LIST_NAV/$catbox/g;
	$resultPage =~ s/!IA_CATEGORY_NAME/$Category/g;
	$resultPage =~ s/!IA_CATEGORY_TREE_NAV/$cattree/g;
	$resultPage =~ s/!IA_ALL_THUMBS/$thumbtable/g;
	$resultPage =~ s/!IA_GALLERY_TITLE/$GalleryTitle/g;
	$resultPage =~ s/!IA_PAGE_NAV/$pagenav/g;
	$resultPage =~ s/!IA_PAGE_STATS/$stats/g;
	$resultPage =~ s/!IA_SORT_BOX/$sort/g;
	$resultPage =~ s/!IA_USER_OPTIONS/$user/g;
	return $resultPage;
}

sub MediaTemplate {
	my($filename) = $SkinPath.$slash.$CategoryList[$CategoryIndex]->{SKIN}.$slash."media.html";
	if(!(-e $filename)) {
		$filename = $SkinPath.$slash.$DefaultSkin.$slash."media.html";
	}
	$fh = OpenFile($filename, "read");
	@template = <$fh>;
	CloseFile(\*$fh);

	$Filename = $cgi->param("file");
	ReadMedia($CategoryIndex);
	for(my $counter = 0; $counter < @MediaList; $counter++) {
		if($MediaList[$counter][$FILENAME] eq $Filename) {
			@ShowData = @{$MediaList[$counter]};
			$MediaIndex = $counter;
			last;
		}
	}	
	IncrementDownload($CategoryIndex, $MediaIndex);

	foreach $line (@template) {
		#if($line =~ /!IA_THUMB/) {
		if($line =~ /^(.*?)!IA_THUMB(.*)$/) {
			$line = $1;
			my(@index) = split(/:/, $2);
			#$line = $line."1: $1<br>2: $2<br>3: $3<br>";
			#foreach $var (@index) {
			#	$line = $line."<b>$var<br>";
			#}
			$line = $line.ThumbHTML($MediaIndex);
			$line = $line.$3;
		}
		if($line =~ /^(.*?)!IA_FIELD(.*)$/) {
			$line = $1;
			my(@index) = split(/:/, $2);
			#$line = $line."1: $1<br>2: $2<br>3: $3<br>";
			#foreach $var (@index) {
			#	$line = $line."<b>$var<br>";
			#}
			$line = $line.MediaField($MediaIndex, int($index[2]));
			$line = $line.$3;
		}
	}
	my($resultPage) = join("",@template);
	$catinline = CategoryInline($Filename);
	$catbox = CategoryDropBox();
	$cattree = CategoryTree();
	$pagenav = ShowNavigation();
	$sort = SortDropBox();
	$user = UserOptions();
	$fullsize = FullsizeHtml();
	
	$resultPage =~ s/!IA_FULLSIZE/$fullsize/g;
	$resultPage =~ s/!IA_CATEGORY_INLINE_NAV/$catinline/g;
	$resultPage =~ s/!IA_CATEGORY_LIST_NAV/$catbox/g;
	$resultPage =~ s/!IA_CATEGORY_NAME/$Category/g;
	$resultPage =~ s/!IA_CATEGORY_TREE_NAV/$cattree/g;
	$resultPage =~ s/!IA_GALLERY_TITLE/$GalleryTitle/g;
	$resultPage =~ s/!IA_PAGE_NAV/$pagenav/g;
	$resultPage =~ s/!IA_SORT_BOX/$sort/g;
	$resultPage =~ s/!IA_USER_OPTIONS/$user/g;
	#print $resultPage;
	return $resultPage;
}


sub CategoryTemplate {
	my($filename) = $SkinPath.$slash.$DefaultSkin.$slash."categorylisting.html";
	$fh = OpenFile($filename, "read") or FatalError("Unable to open $filename for reading!<br>Reason: $!");
	@template = <$fh>;
	CloseFile(\*$fh);

	my($resultPage) = join("",@template);
	$catbox = CategoryDropBox();
	$cattree = CategoryTree();
	$sort = SortDropBox();
	$user = UserOptions();
	$cattable = CategoryTable();

	$resultPage =~ s/!IA_CATEGORY_TABLE/$cattable/g;
	$resultPage =~ s/!IA_CATEGORY_LIST_NAV/$catbox/g;
	$resultPage =~ s/!IA_CATEGORY_TREE_NAV/$cattree/g;
	$resultPage =~ s/!IA_GALLERY_TITLE/$GalleryTitle/g;
	$resultPage =~ s/!IA_SORT_BOX/$sort/g;
	$resultPage =~ s/!IA_USER_OPTIONS/$user/g;
	#print $resultPage;
	return $resultPage;
}

sub UserOptions {
	my($html) = qq~
	<!-- UserOptions -->
	<table border="0" width="100%" cellspacing="0" cellpadding="0" class="UserOptionsStyle">
    <tr>
    <td width="100%" class="UserOptionsStyle">
	  <font face="$FontFace" color="$FontColor" size="$FontSize" class="UserOptionsStyle">
		~;
	  if($LoggedIn eq "true") {
		  $html = $html.qq~ Hello $Username, you have these options: ~;
	  }	else {
		  $html = $html.qq~ User Options: ~;
	  }
	  $html = $html.qq~
		</font>
	</td>
	</tr>
	<tr>
	<td width="100%" align="center" class="UserOptionsStyle">
	  <font face="$FontFace" color="$FontColor" size="$FontSize" class="UserOptionsStyle">
	  <a href="$GalleryUrl/$GalleryCgi">Home</a> | 
	  ~;
	  if(GetPermission("AccessAdmin")) {
		$html = $html.qq~<a href="$GalleryUrl/$ConfigCgi">Admin</a> | ~;
	  }
	  if($LoggedIn eq "true") {
		$html = $html.qq~<a href="$GalleryUrl/$GalleryCgi?func=logout">Logout</a>~;
	  } else {
		$html = $html.qq~<a href="$GalleryUrl/$GalleryCgi?func=showlogin">Login</a>~;
	  }
	  #| <a href="$GalleryUrl/$GalleryCgi?func=viewprofile">Profile</a> 
	  $html = $html.qq~
	  | <a href="$GalleryUrl/$GalleryCgi?func=showregister">Register</a> 
	  | <a href="$GalleryUrl/$GalleryCgi?func=showupload&Category=$CategoryIndex">Post Image</a> 
	  | <a href="$GalleryUrl/$GalleryCgi?func=search&Category=$CategoryIndex">Search</a>~;
	  if($DisplaySort eq "true") {
		$html = $html.qq~ | <a href="$GalleryUrl/$GalleryCgi?func=showsort">Sort</a></font>~;
	  }
	  $html = $html.qq~
	</td>
    </tr>
    </table>
	<!-- End UserOptions -->
	~;
	return $html;
}

sub RegisterTemplate {
	my($html) = qq~
	<center>
	<form action="$GalleryUrl/$GalleryCgi" method="POST">
	<input type="hidden" name="func" value="register">
	<table border=0 cellpadding=2 cellspacing=1 width="100%">
	  <tr>
	    <td align="center" colspan=2><font size=$FontSize color='$FontColor' face='$FontFace'>
		<h3>Register with $GalleryTitle</h3>
		</td>
	  </tr>
	</table>
	<table border=0 cellpadding=2 cellspacing=1 width="75%">
	  <tr>
		<td align="right"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Name:</b></td>
		<td align="left"><input type=text name="name" size=20></td>
	  </tr>
	  <tr>
		<td align="right"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Username:</b></td>
		<td align="left"><input type=text name="username" size=20></td>
	  </tr>
	  <tr>
		<td align="right"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Password:</b></td>
		<td align="left"><input type=input name="password" size=20></td>
	  </tr>
	  <tr>
		<td align="right"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Email:</b></td>
		<td align="left"><input type=input name="email" size=20></td>
	  </tr>
	  <tr>
		<td colspan="2" align="center"><input type=submit value="Register"></td>
	  </tr>
	</table>
	</form>
	</center>
	~;
	return BlankTemplate($html);
}

sub UploadTemplate {
	$upload = $MaxUpload / 1000;
	$Message = qq~
	  <table border="0" width="100%">
	    <tr>
		  <td width="100%"><font size="$FontSize" face="$FontFace"><big>Upload Media<blockquote></big>
		<small>Note: If you do not specify a thumbnail and the appropriate thumbnail processing plugin
		is not installed, a default image will be used.</blockquote></small></td>
	    </tr>
	  <tr>
	  <td align="center">
	  <form enctype="multipart/form-data" action="$GalleryCgi" method="POST" name="FORM">
	  <input type="hidden" name="func" value="upload">
	  <table border="0" width="90%">
		<tr><td width="2%" align="right"><font size="$FontSize" face="$FontFace">Username:</font></td>
		  <td width="56%"><input type="text" name="username" size="20"></font></td>
		</tr>
		<tr><td width="2%" align="right"><font size="$FontSize" face="$FontFace">Password:</font></td>
	      <td width="56%"><input type="password" name="password" size="20"></font></td>
		</tr>
	    <tr><td width="2%" align="right"><font size="$FontSize" face="$FontFace">Media:</font></td>
		  <td width="56%"><input type="file" name="filename" size="20"></font></td>
		</tr>
		<tr><td width="2%" align="right"><font size="$FontSize" face="$FontFace">Thumbnail:</font></td>
	      <td width="56%"><input type="file" name="thumbnail" size="20"></font></td>
		</tr>
		  <tr><td width="25%" align="right"><font size="$FontSize" face="$FontFace">Category:</font></td>
		  <td width="25%" align="left"><font face="$FontFace">
		~;
		if($Category ne "NONE") {
			$Message = $Message.CategoryInline();
			$Message = $Message.qq~<input type="hidden" name="Category" value="$CategoryIndex">~;
		} else {
			$Message = $Message.qq~
				<select name="Category" class="CatListBoxStyle">
			~;
			for(my($counter) = 0; $counter < @CategoryList; $counter++) {
				$Message = $Message.qq~ <option value="$CategoryList[$counter]->{INDEX}"> ~;
				for(my($num) = 0; $num < @CategoryList[$counter]->{DEPTH}; $num++) {
					$Message = $Message."&nbsp;&nbsp;&nbsp;";
				}
				$Message = $Message.qq~$CategoryList[$counter]->{NAME}</option> ~;
			}
			$Message = $Message.qq~</select>~;
		}
		$Message = $Message.qq~
		</font></td>
		</tr>
		  <tr><td width="25%" align="right"><font size="$FontSize" face="$FontFace">Description:</font></td>
	      <td width="25%" align="left"><textarea rows="6" name="description" cols="35"></textarea></font></td>
		</tr>
		<tr>
		  <td width="19%" align="right">
		  <font size="$FontSize" face="$FontFace">Author:&nbsp;</font>
		  </td>
		  <td width="81%"><input type="text" name="author" size="30"></font></td>
		</tr>
		<tr>
		  <td width="19%" align="right">
		  <font size="$FontSize" face="$FontFace">Copyright:&nbsp;</font>
		  </td>
		  <td width="81%"><input type="text" name="copyright" size="30"></font></td>
		</tr>
		<tr><td width="25%" ></td>
		  <td width="25%" align="left"><input type="submit" value="Upload"></font></td>
		</tr>
		</table>
		<table border="0"><tr><td><font size="$FontSize" face="$FontFace"><small>*Maximum Image size is $upload k including thumbnail<br>Only click on 'Upload' once!</font></td></tr></table>
		~;
		$Message = $Message.LoadUserJavaCode().qq~
	  </form>
	 </td>
	  </tr>
	 </table>
	~;
	return BlankTemplate($Message);
}

sub LoginTemplate {
	my $message = shift;
	$html = qq~
	<center>
	<form action="$GalleryUrl/$GalleryCgi" method="POST">
	<input type="hidden" name="func" value="login">
	<table border=0 cellpadding=2 cellspacing=1 width="300">
	~;
	if($message) {
	$html = $html.qq~
	  <tr>
	    <td align="center" colspan="2"><font size=$FontSize color='$FontColor' face='$FontFace'><b>$message</b></font></td>
	  </tr>
	~;
	}
	$html = $html.qq~
	  <tr>
		<td align="left"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Username:</b></td><td align="right"><input type=text name="username" size=20></td>
	  </tr>
	  <tr>
		<td align="left"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Password:</b></td><td align="right"><input type=password name="password" size=20></td>
	  </tr>
	  <tr>
		<td colspan="2" align="right"><input type=submit value="Log In"><br><font size=$FontSize color='$FontColor' face='$FontFace'><!--<small><a href="Reminder.pl?action=input_user">Forgot password?</small>--></td>
	  </tr>
	</table>
	</form>
	</center>
	~;
	return BlankTemplate($html);
}

sub SearchTemplate {
	$Category = $cgi->param("Category");
	$html = qq~
	<center>
	<b>Search the Gallery</b>
	<form action="$GalleryUrl/$GalleryCgi" method="POST">
	<input type="hidden" name="func" value="search">
	<input type="hidden" name="Category" value="$Category">
	<table border=0 cellpadding=2 cellspacing=1 width="300">
	  <tr>
		<td align="left"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Search For:</b></td><td align="right"><input type=text name="searchterm" size=30></td>
	  </tr>
	  <tr>
		<td align="left"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Field to Search:</b></td>
		<td align="right"><select name="searchfield">
		<option value="-1" selected>All Fields
		<option value="0">Filename
		<option value="3">Date Added
		<option value="5">Author
		<option value="9">Description
		<option value="10">User Uploads
		</select>
		</td>
	  </tr>
	  <tr>
		<td colspan="2" align="right"><input type=submit value="Search"><br></td>
	  </tr>
	</table>
	</form>
	</center>
	~;
	return BlankTemplate($html);
}

sub SortTemplate {
	$Category = $cgi->param("Category");
	@SortList = split(/\|/, $SortValues);
	my($html) = qq~
	<center>
	<b>Set Sort Preference</b>
	<form action="$GalleryUrl/$GalleryCgi" method="POST">
	<input type="hidden" name="func" value="setsort">
	<input type="hidden" name="Category" value="$Category">
	<table border=0 cellpadding=2 cellspacing=1 width="300">
	  <tr>
		<td align="left"><font size=$FontSize color='$FontColor' face='$FontFace'><b>Default field to sort on:</b></td>
		<td align="right"><select name="sort">
		~;
		if($SortBy eq "") { $SortBy = $DefaultSort; }
		foreach $sort (@SortList) {
			if($sort eq $SortBy) {
				$html = $html.qq~<option value="$sort" selected>$sort~;
			} else {
				$html = $html.qq~<option value="$sort">$sort~;
			}
		}
		$html = $html.qq~
		</select>
		</td>
	  </tr>
	  <tr>
		<td colspan="2" align="right"><input type=submit value="Ok"><br></td>
	  </tr>
	</table>
	</form>
	</center>
	~;
	return BlankTemplate($html);
}

sub BlankTemplate {
	my $message = shift;
	my($filename) = $SkinPath.$slash.$DefaultSkin.$slash."blank.html";
	$fh = OpenFile($filename, "read");
	@template = <$fh>;
	CloseFile(\*$fh);

	my($resultPage) = join("",@template);
	$catbox = CategoryDropBox();
	$cattree = CategoryTree();
	$sort = SortDropBox();
	$user = UserOptions();

	$resultPage =~ s/!IA_MESSAGE/$message/g;
	$resultPage =~ s/!IA_CATEGORY_LIST_NAV/$catbox/g;
	$resultPage =~ s/!IA_CATEGORY_TREE_NAV/$cattree/g;
	$resultPage =~ s/!IA_GALLERY_TITLE/$GalleryTitle/g;
	$resultPage =~ s/!IA_SORT_BOX/$sort/g;
	$resultPage =~ s/!IA_USER_OPTIONS/$user/g;
	return $resultPage;
}

sub ParseMessageTemplate {
	my ($TemplateFile, $Message, $Title) = shift;
	$fh = OpenFile($TemplateFile, "read");
	@template = <$fh>;
	close($fh);
	my($resultPage) = join("",@template);
	$resultPage =~ s/!IA_TITLE/$Title/g;
	$resultPage =~ s/!IA_MESSAGE/$Message/g;
	return $resultPage;
}

1;