##############################################################
#
# This code is copyright iKing Networks 2000, 2001.
#
#  iKing Networks offers no warranties on this script.  
#  The user of the script is solely responsible for 
#  any problems caused by installation of the script or use 
#  of the script.
#
#  All copyright notices regarding Arcadia scripts and iKing
#  Networks must remain intact on the scripts and in the HTML
#  for the scripts.
#
#  http://www.ikingnet.com
#
###############################################################

# uiglib.cgi

#set USEFLOCK to 1 to use flock() or 0 for no file locking
$USEFLOCK = 1;
#comment out below if not using flock...
use Fcntl ':flock';


$UIGVersion = "2.8.1";

#$TITLE;
#$CATEGORY;
#keep these date variables global.  GetDate returns a string of the 3.
#this way if we need them they are there after GetDate is called
$mday = 0;
$mon = 0;
$year = 0;
$hour = 0;

#lists of data collected from image.data , Filled by Read_Categories
@ImageList=();
#list of all images in directory even if they are not listed in image.data
@picnames=();
#List of all the possible categories from categories.data
@CategoryList=();
#Number of total pictures...
$totalpictures=0;
#Number of total pages...
$totalpages=0;
#Page being displayed...
$page=1;
@Downloads=();

###########################################################
# Media Functions
###########################################################

sub EncodeURL {
	my $text = shift;
	$text =~ s/([^a-z0-9_.!~*'() -])/sprintf "%%%02X", ord($1)/ei;
	$text =~ tr/ /+/;
	return $text;
}

sub DecodeURL {
	my $text = shift;
	$text =~ tr/\+/ /;
	$text =~ s/%([a-f0-9][a-f0-9])/chr( hex( $1 ) )/ei;
	return $text;
}

###########################################################
# Sort Functions
###########################################################

sub BySpecified {
	($field1, $field2) = @_;
	$cat_a = $a->[$field1];
	$cat_b = $b->[$field1];
	#first compare by category
	$result = $cat_a cmp $cat_b;
	if($result == 0) {	
		#compare by filename
		$cat_a = $a[$field2];
		$cat_b = $b[$field2];
		$result = $cat_a cmp $cat_b;
	}
	return $result;
}

sub ByFilename {
	#compare by filename
	$cat_a = $a->[$FILENAME];
	$cat_b = $b->[$FILENAME];
	return $cat_a cmp $cat_b;
}

sub ByThumbnail {
	$cat_a = $a->[$THUMBNAME];
	$cat_b = $b->[$THUMBNAME];
	return $cat_a cmp $cat_b;
}

sub ByType {
	$cat_a = $a->[$TYPE];
	$cat_b = $b->[$TYPE];
	return $cat_a cmp $cat_b;
}

sub ByDate {
	$cat_a = int(DateTimeToJulian($a->[$DATE]));
	$cat_b = int(DateTimeToJulian($b->[$DATE]));
	return $cat_a <=> $cat_b;
}

sub ByCopyright {
	#compare by copyright
	$cat_a = $a->[$COPYRIGHT];
	$cat_b = $b->[$COPYRIGHT];
	return $cat_a cmp $cat_b;
}

sub ByAuthor {
	#compare by author
	$cat_a = $a->[$AUTHOR];
	$cat_b = $b->[$AUTHOR];
	return $cat_a cmp $cat_b;
}

sub ByDownloads {
	$cat_a = int($a->[$DOWNLOADS]);
	$cat_b = int($b->[$DOWNLOADS]);
	return $cat_b <=> $cat_a;
}

sub ByVotes {
	$cat_a = int($a->[$VOTES]);
	$cat_b = int($b->[$VOTES]);
	return $cat_b <=> $cat_a;
}

sub ByRating {
	$cat_a = int($a->[$RATING]);
	$cat_b = int($b->[$RATING]);
	return $cat_b <=> $cat_a;
}


sub SortMediaList {
	$byfilename = @_;
	if($byfilename == 1){
		@MediaList = sort ByDownload @MediaList;		
	} else {
		@MediaList = sort ByFilename @MediaList;
	}
}

###########################################################
# Misc. Functions
###########################################################

sub CalcExistingPages {
	$MaxPerPage = $PageColumns * $PageRows;
	$TotalPages = int(@MediaList / $MaxPerPage);
	if(@MediaList % $MaxPerPage) {
		$TotalPages++;
	}
}

sub CalcNewPages {
	$totalpages = int(@picnames / $maxperpage);
	if(@picnames % $maxperpage) {
		$totalpages++;
	}
}

sub GetDate {
	($hour,$mday,$mon,$year) = (localtime(time))[2,3,4,5];
	$year += 1900;
	#$date = "$mday $mon+1 $year";
	$mon = $mon+1;
	if ($mon < 10) { $mon = "0".$mon; }
	if ($mday < 10) { $mday = "0".$mday; }
	$date = $mon."/".$mday."/".$year;
	return $date;	
}

sub OpenFile
{
	my($filename) = shift;
	my($type) = shift;
	local *FH;
	if($type eq "write") {
		open(FH, ">$filename") or FatalError("Can't open $filename for writing! $!");
		eval{ flock(FH, LOCK_EX); };
	} elsif($type eq "read") {
		open(FH, "<$filename") or FatalError("Can't open $filename for reading! $!");
		eval{ flock(FH, LOCK_SH); };
	} elsif($type eq "append") {
		open(FH, ">>$filename") or FatalError("Can't open $filename for appending! $!");
		eval{ flock(FH, LOCK_EX); };
	} else {
		Write_Message("Invalid file type for opening! in OpenFile($filename)",1);
	}
	return *FH;
}

sub CloseFile
{
	my($file) = shift;
	eval{ flock($file, LOCK_UN); };
	close($file);		  	
}	

sub ReadFileTypes {
	my($filename) = $MediaPath.$slash."file.types";
	if(!(-e "$filename")) {
		$fh = OpenFile($filename, "write");
		print $fh qq~Image/JPEG|jpg|samewindow|<img src="<!FILENAME>" border="0">\n~;
		print $fh qq~Image/GIF|gif|samewindow|<img src="<!FILENAME>" border="0">\n~;
		print $fh qq~Image/PING|png|samewindow|<img src="<!FILENAME>" border="0">\n~;
		print $fh qq~Movie/Quicktime|mov|samewindow|<embed controller="true" width="320" height="280" target="myself" src="<!FILENAME>" border="0" pluginspage="http://www.apple.com/quicktime/download/indext.html"></EMBED>\n~;
		CloseFile(\*$fh);
		chmod(0666, "$filename");
	}
	$fh = OpenFile($filename, "read");
	while(<$fh>) {
		my $line = $_;
		chomp($line);
		my @list = split('\|', $line);
		if($list[0] ne "" && $list[1] ne "" && $list[2] ne "") {
			# To determine the class from the file type
			$FileClass{lc("$list[1]")} = $list[0];
			# To determine the ext from the class
			$FileExts{"$list[0]"} = lc($list[1]);
			# To determine the src code from the class
			$FileCode{"$list[0]"} = $list[3];
			# which window to open into...
			$FileOpen{"$list[0]"} = $list[2];
		}
	}
	CloseFile(\*$fh);
}

sub WriteFileTypes {
	@filekeys = keys(%FileExts);
	my($filename) = $MediaPath.$slash."file.types";
	$fh = OpenFile($filename, "write");
	if(defined $fh) {
		for(my($counter) = 0; $counter < @filekeys; $counter++) {
			if($filekeys[$counter] ne "" && $FileExts{$filekeys[$counter]} ne "" && $FileCode{$filekeys[$counter]} ne "") {
				print $fh $filekeys[$counter]."|".$FileExts{$filekeys[$counter]}."|".$FileOpen{$filekeys[$counter]}."|".$FileCode{$filekeys[$counter]}."\n";
			}
		}
		CloseFile(\*$fh);
	}
}

sub GetVersion {
	$UIGVersion;	
}

sub GoodStartDate {
	my $startdate = shift;
	if($startdate eq "") { return 1; }
	GetDateTime();
	my ($cmon, $cday, $cyear) = split(/\//, $startdate);
	if($JSYear > $cyear) { return 1; }
	if($mon > $cmon) { return 1; }
	if($mday > $cday && $mon == $cmon) { return 1; }
	return 0;
}

sub GoodEndDate {
	my $enddate = shift;
	if($enddate eq "") { return 1; }
	GetDateTime();
	my ($cmon, $cday, $cyear) = split(/\//, $enddate);
	if($JSYear < $cyear) { return 1; }
	if($mon < $cmon) { return 1; }
	if($mday < $cday && $mon == $cmon) { return 1; }
	return 0;
}

sub GetDateTime  {
	($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime (time);
	$mon++;
	$JSMonth = $mon;
	$JSYear = $year + 1900;
	$JulianDate = &JulianDay($JSMonth, $mday, $JSYear);
	$hour = sprintf ("%2d", $hour);
	$hour =~tr/ /0/;
	$min = sprintf ("%2d", $min);
	$min =~tr/ /0/;
	$sec = sprintf ("%2d", $sec);
	$sec =~tr/ /0/;
	$JSTime = ("$hour" . "$min");
	$LastLoginJulian = ($JulianDate + ($JSTime * 0.0001));
	$SearchJulian = ("$LastLoginJulianDATE" . "-$JSTime$sec");
	NormalTime();
	$min = sprintf ("%2d", $min);
	$min =~tr/ /0/;
	$mon = sprintf ("%2d", $mon);
	$mon =~tr/ /0/;
	$mday = sprintf ("%2d", $mday);
	$mday =~tr/ /0/;
	$HyphenDate = ("$mon" . "-" . "$mday" . "-" . "$JSYear");
	$EuroDate = ("$mday" . "-" . "$mon" . "-" . "$JSYear");
	$RunonDate = ("$mon$mday$year");
	$Time = ("$hour" . ":" . "$min" . " " . "$AMPM");
	$DateTime = ("$HyphenDate $Time");
}

# for Image Arcadia formatted dates
sub DateTimeToJulian {
	my($datetime) = shift;
	my($date,$time,$ampm) = split(/ /, $datetime);
	my($mon, $day, $year) = split(/-/, $date);
	my($hour,$min) = split(/:/, $time);
	$JulianTime = ("$hour"."$min");
	$JulianDate = JulianDay($mon, $day, $Year);
	$JulianDateTime = ($JulianDate + ($JulianTime * 0.0001));
	return $JulianDateTime;
}
sub NormalTime {		
	if ($hour < 12) {
		$AMPM = "AM";
	}
	if ($hour > 12) {
		$hour = $hour - 12;
		$AMPM = "PM";
	}  	
	if ($hour == 12) {
		$AMPM = "PM";
	}  	
	if ($hour == 0) {
		$hour = "12";
	}
	$hour = sprintf ("%2d", $hour);
	$hour =~tr/ /0/;
}

sub MilitaryTime {
	if ($AMpm eq "PM") {		
		if ($hour < 12) {
			$hour = ($hour  + 12);
		}
	}
	if ($AMpm eq "AM") {		
		if ($hour == 12) {
			$hour = "0";
		}
	}
	$hour = sprintf ("%2d", $hour);
	$hour =~tr/ /0/;
	$min = sprintf ("%2d", $min);
	$min =~tr/ /0/;
}

		
sub MilitaryTime2 {
	if ($AMpm eq "PM") {		
		if ($GetHour < 12) {
			$MilHour = ($GetHour  + 12);
		}  else {
			$MilHour = $GetHour;
		}	
	}
	if ($AMpm eq "AM") {		
		if ($GetHour == 12) {
			$MilHour = "0";
		}  else {
			$MilHour = $GetHour;
		}	
	}
	$MilHour = sprintf ("%2d", $MilHour);
	$MilHour =~tr/ /0/;
	$GetMinute = sprintf ("%2d", $GetMinute);
	$GetMinute =~tr/ /0/;
}

sub JulianDay {
	local($m,$d,$y) = @_;
	local($ya,$c);
	$y = (localtime(time))[5] + 1900  if ($y eq '');
	if ($m > 2) {
		$m -= 3;
	} else {
		$m += 9;
		--$y;
	}
	$c = int($y/100);
	$ya = $y - (100 * $c);
	$jd =  int((146097 * $c) / 4) +
		   int((1461 * $ya) / 4) +
		   int((153 * $m + 2) / 5) +
		   $d + 1721119;
	return $jd;
}

1;